package contabilidad.beans;

import contabilidad.entity.Ejercicio;
import contabilidad.entity.PlanContable;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Component("contabi_EjercicioBean")
public class EjercicioBean {

    @Autowired
    private DataManager dataManager;

    public int devuelveAnnoParaNuevoEjercicioPara(PlanContable pc) throws Exception{
        String eql = "select ej from contabi_Ejercicio ej join ej.planContable pc where pc.id = :pcid order by ej.anno desc";
        List<Ejercicio> ejs = dataManager.load(Ejercicio.class).query(eql).parameter("pcid", pc.getId())
                .list();
        if (ejs.size()>0){
            Ejercicio ej = ejs.get(0);
            return ej.getAnno() + 1;
        }else{
            return new Integer(new SimpleDateFormat("yyyy").format(new Date()));
        }
    }

    public Ejercicio devuelveEjercicioCorrespondienteAFecha(Date fecha, PlanContable pc) throws Exception{
        String eql = "select ej from contabi_Ejercicio ej join ej.planContable pc where pc.id = :pcid " +
                " and ej.fechaInicio <= :fecha and ej.fechaFin >= :fecha ";
        Ejercicio ej = dataManager.load(Ejercicio.class).query(eql).parameter("pcid", pc.getId())
                .parameter("fecha", fecha).one();
        return ej;
    }

}