package contabilidad.beans.app;

import contabilidad.beans.AsientoBean;
import contabilidad.beans.ConceptoApunteBean;
import contabilidad.beans.EjercicioBean;
import contabilidad.beans.SaldosBean;
import contabilidad.entity.*;


import io.jmix.core.DataManager;


import org.apache.commons.lang3.StringUtils;
import org.apache.tomcat.util.json.JSONParser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


import java.text.SimpleDateFormat;
import java.util.*;


@Component("contabi_ContabilizacionExternaBean")
public class ContabilizacionExternaBean {

    @Autowired
    DataManager dataManager;

    boolean sufijosCCInitialized = false;
    Hashtable<String, String> sufijosCC = new Hashtable<>();
    @Autowired
    private AsientoBean asientoBean;
    @Autowired
    private EjercicioBean ejercicioBean;
    @Autowired
    private SaldosBean saldosBean;
    @Autowired
    private ConceptoApunteBean conceptoApunteBean;

    private void initSufijosCC(){
        if (!sufijosCCInitialized){
            sufijosCC.put("A19","019");
            sufijosCC.put("AC135","");
            sufijosCC.put("AC135L7","");
            sufijosCC.put("ASAM","000");
            sufijosCC.put("ASM_GUADALEST","101");
            sufijosCC.put("ASM_MARVALLOS","004");
            sufijosCC.put("AXES8","001");
            sufijosCC.put("C 5","");
            sufijosCC.put("C17E","018");
            sufijosCC.put("C389","005");
            sufijosCC.put("CC97","016");
            sufijosCC.put("CO107","006");
            sufijosCC.put("CO5","");
            sufijosCC.put("D10","000");
            sufijosCC.put("EG10","006");
            sufijosCC.put("F43","");
            sufijosCC.put("G72","014");
            sufijosCC.put("GVCC489","");
            sufijosCC.put("L41","020");
            sufijosCC.put("L'ALDEA","");
            sufijosCC.put("MP65","017");
            sufijosCC.put("N39","");
            sufijosCC.put("PALLARS","");
            sufijosCC.put("PIM101","002");
            sufijosCC.put("PL18","");
            sufijosCC.put("R10","");
            sufijosCC.put("R216","021");
            sufijosCC.put("R230","005");
            sufijosCC.put("R37","008");
            sufijosCC.put("R42","007");
            sufijosCC.put("RA55","003");
            sufijosCC.put("RB55","004");
            sufijosCC.put("S40","");
            sufijosCC.put("S545","013");
            sufijosCC.put("SA22","015");
            sufijosCC.put("TOSSAL13","004");
            sufijosCC.put("V60","001");
            sufijosCC.put("V62","002");
            sufijosCC.put("V64","003");
            sufijosCC.put("VA276","012");
            sufijosCCInitialized = true;
        }

    }

    public Asiento realizaAsientoDesdePublicacionRemota(PublicacionRemota pr) throws Exception{
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
        this.initSufijosCC();

        String json = pr.getContenido();
        JSONParser parser = new JSONParser(json);
        Map m = (Map) parser.parse();
        String fechaFacturaStr = (String) m.get("FECHA_FACTURA");
        Date fechaFactura = sdf.parse(fechaFacturaStr);

        String nifReceptor = (String) m.get("NIF_RECEPTOR");
        //DETERMINACION DEL PLAN CONTABLE
        PlanContable pc = null;
        if (nifReceptor.compareTo("B08377079")==0){
            pc = dataManager.load(PlanContable.class).query("select pc from contabi_PlanContable pc " +
                    "where pc.nombre like 'GUADAL'").one();
        }
        if (nifReceptor.compareTo("B65687766")==0){
            pc = dataManager.load(PlanContable.class).query("select pc from contabi_PlanContable pc " +
                    "where pc.nombre like 'MARVAL'").one();
        }


        String nifEmisor = (String) m.get("NIF_EMISOR");
        //DETERMINACION DE LA CUENTA DE PROVEEDOR Y TIPO DE CUENTA DE GASTO
        String codigoCuentaProveedor = null;
        String prefijoCuentaGasto = null;
        List<Asiento> aa = dataManager.load(Asiento.class).query("select distinct a from contabi_MovtoIva miva " +
                "join miva.asiento a join a.ejercicio ej join ej.planContable pc " +
                        "WHERE miva.nif = :nif and pc.id = :pcid").parameter("nif", nifEmisor)
                .parameter("pcid", pc.getId())
                .maxResults(25).fetchPlan("asiento-print").list();
        if (aa.size()>0){
            //no hacemos nada
        }else{
            aa = dataManager.load(Asiento.class).query("select distinct a from contabi_MovtoIrpf mirpf " +
                    "join mirpf.asiento a WHERE mirpf.nif = :nif").parameter("nif", nifEmisor)
                    .maxResults(25).fetchPlan("asiento-print").list();
            if (aa.size()>0){
                //no hacemos nada
            }else{
                throw new Exception("No se puede determinar la cuenta del proveedor. Puede ser que no exista histórico para este emisor.");
            }
        }
        a:
        for (int i = 0; i < aa.size(); i++) {
            Asiento a = aa.get(i);
            codigoCuentaProveedor = null;
            prefijoCuentaGasto = null;
            //ha de haber una cuenta en el haber
            List<Apunte> aps = a.getApuntes();
            for (int j = 0; j < aps.size(); j++) {
                Apunte ap = aps.get(j);
                if (!ap.getDebeHaber()){
                    //determinacion de la cuenta del proveedor
                    if (ap.getCuentaContable().getCodigo().substring(0,1).compareTo("4")==0){
                        if (ap.getCuentaContable().getCodigo().substring(0,2).compareTo("47")!=0){
                            codigoCuentaProveedor = ap.getCuentaContable().getCodigo();
                        }

                    }
                }
                if (ap.getDebeHaber()){
                    //determinacion de los 3 primeros digitos de la cuenta de gasto
                    if ((ap.getCuentaContable().getCodigo().substring(0,1).compareTo("6")==0)
                    || (ap.getCuentaContable().getCodigo().substring(0,2).compareTo("34")==0)){
                        prefijoCuentaGasto = ap.getCuentaContable().getCodigo().substring(0,3);
                    }
                }
                if ((codigoCuentaProveedor!=null) && (prefijoCuentaGasto!=null)){
                    break a;
                }
            }

        }
        //FIN DETERMINACION CUENTA PROVEEDOR Y PREFIJO CUENTA DE GASTO

        ArrayList ubicaciones = new ArrayList();
        ArrayList deptos = new ArrayList();
        Hashtable<String, List<Map>> sufijosImputaciones = new Hashtable<>();
        ArrayList<Map> imputaciones = (ArrayList) m.get("imputaciones");
        for (int i = 0; i < imputaciones.size(); i++) {
            Map imputacion = imputaciones.get(i);
            String ubicacion = (String) imputacion.get("UBICACION");
            String departamento = (String) imputacion.get("DEPARTAMENTO");
            String sufijo = determinaSufijoPara(ubicacion, departamento, pc);
            ArrayList<Map> imputacionesSufijo;
            if (!sufijosImputaciones.containsKey(sufijo)){
                imputacionesSufijo = new ArrayList<Map>();
                sufijosImputaciones.put(sufijo, imputacionesSufijo);
            }else{
                imputacionesSufijo = (ArrayList) sufijosImputaciones.get(sufijo);
            }
            imputacionesSufijo.add(imputacion);

        }

        ArrayList<Map> conceptosAdicionales = (ArrayList) m.get("conceptos_adicionales");
        //PENDIENTE

        //CREANDO EL ASIENTO
        Asiento a = dataManager.create(Asiento.class);
        a.setFuente("SOFIA");

        a.setFecha(fechaFactura);
        a.setFechaRegistro(new Date());
        Ejercicio ej = ejercicioBean.devuelveEjercicioCorrespondienteAFecha(fechaFactura, pc);
        a.setEjercicio(ej);

        Integer numAsto = asientoBean.getNuevoNumAsiento(ej);
        a.setNumAsiento(numAsto);
        a.setPointersArchivosAdjuntosExtDoc(new ArrayList<>());
        if (m.containsKey("ARCHIVO_ADJUNTO_EXTDOCS_ID")){
            Integer aaedid = ((Number) m.get("ARCHIVO_ADJUNTO_EXTDOCS_ID")).intValue();
            PointerArchivoAdjuntoExtDoc p = dataManager.create(PointerArchivoAdjuntoExtDoc.class);
            p.setArchivoAdjuntoExtDocId(aaedid);
            p.setAsiento(a);
            a.getPointersArchivosAdjuntosExtDoc().add(p);
            try {
                ArchivoAdjuntoExtDocs aaed = dataManager.load(ArchivoAdjuntoExtDocs.class)
                        .query("select aa from contabi_ArchivoAdjuntoExtDocs aa where aa.id = :id")
                        .parameter("id", aaedid)
                        .one();
                p.setArchivoAdjuntoExtDoc(aaed);
            }catch(Exception exc){
                //de momento no hacemos nada
                //una vez importado rentamasterdocs, debería lanzar una excepcion
            }
        }

        List<Apunte> apuntes = new ArrayList<>();

        Apunte apProv = dataManager.create(Apunte.class);
        apProv.setAsiento(a);
        apProv.setImporte((Double) ((Number)m.get("IMPORTE_TOTAL_FACTURA")).doubleValue());
        CuentaContable ccProv = saldosBean.getCuentaContableDesdeCodigoYPlanContable(codigoCuentaProveedor, pc);
        apProv.setCuentaContable(ccProv);
        apProv.setDebeHaber(false);
        apProv.setConceptoApunte(conceptoApunteBean.devuelveConceptoApunteDesdeCodigo("081"));
        apProv.setNumApunte(apuntes.size()+1);
        apProv.setAmpliacion((String)m.get("NOMBRE_EMISOR") + " " + (String) m.get("NUM_FRA"));
        apuntes.add(apProv);

        String ampl = null;

        Iterator<String> sufijos = sufijosImputaciones.keySet().iterator();
        while(sufijos.hasNext()){
            String sufijo = sufijos.next();
            List<Map> imps = (List<Map>) sufijosImputaciones.get(sufijo);
            for (int i = 0; i < imps.size(); i++) {
                Map mi = (Map) imps.get(i);
                Apunte ap = dataManager.create(Apunte.class);
                ap.setAsiento(a);
                ap.setNumApunte(apuntes.size()+1);
                ap.setImporte((Double) ((Number)mi.get("IMPORTE_IMPUTACION")).doubleValue());
                ap.setDebeHaber(true);
                String amplImp = "";
                if (ampl == null){
                    ampl = (String)m.get("NOMBRE_EMISOR") + " " + (String) m.get("NUM_FRA");
                }
                if ((mi.containsKey("UBICACION")) && (((String)mi.get("UBICACION")).length()>0)){
                    amplImp += " " + (String) mi.get("UBICACION");
                }
                if ((mi.containsKey("DEPARTAMENTO")) && (((String)mi.get("DEPARTAMENTO")).length()>0)){
                    amplImp += (String) mi.get("DEPARTAMENTO");
                }
                ap.setAmpliacion(ampl + amplImp);
                ap.setConceptoApunte(conceptoApunteBean.devuelveConceptoApunteDesdeCodigo("081"));

                String codigo = prefijoCuentaGasto + StringUtils.repeat("0", 8 - (prefijoCuentaGasto.length() + sufijo.length())) + sufijo;
                CuentaContable ccap = saldosBean.getCuentaContableDesdeCodigoYPlanContable(codigo, pc);
                ap.setCuentaContable(ccap);
                apuntes.add(ap);
            }
        }

        Double sumaIva = 0.0;
        Double sumaIrpf = 0.0;

        a.setApuntes(apuntes);

        a.setMovtosIva(new ArrayList());
        a.setMovtosIrpf(new ArrayList());

        //iva e irpf
        List<Map> conceptos_adicionales = (List) m.get("conceptos_adicionales");
        for (int i = 0; i < conceptos_adicionales.size(); i++) {
            Map mca = conceptos_adicionales.get(i);
            if ((!mca.containsKey("PORCENTAJE_CONCEPTO")) && (((Number)mca.get("IMPORTE_APLICADO")).doubleValue()==0.0)){
                //no se contabiliza
                continue;
            }
            if (((String)mca.get("NOMBRE_CONCEPTO")).compareTo("IVA")==0){
                MovtoIva miva = dataManager.create(MovtoIva.class);
                miva.setFechaDeFactura(fechaFactura);
                miva.setFechaDeclIva(new Date());
                miva.setAsiento(a);
                miva.setNumFra((String) m.get("NOMBRE_EMISOR") + " " + (String)m.get("NUM_FRA"));
                miva.setNombre((String) m.get("NOMBRE_EMISOR"));
                miva.setNif((String)m.get("NIF_EMISOR"));
                miva.setTipoMovto(TipoMovtoIva.REC);
                miva.setImporteBase(((Number) mca.get("BASE_CONCEPTO")).doubleValue());
                if (!mca.containsKey("PORCENTAJE_CONCEPTO")){
                    miva.setTipoPorcentaje(0.0);
                }else{
                    miva.setTipoPorcentaje(((Number) mca.get("PORCENTAJE_CONCEPTO")).doubleValue());
                }

                miva.setCuota(((Number) mca.get("IMPORTE_APLICADO")).doubleValue());
                a.getMovtosIva().add(miva);
                sumaIva += miva.getCuota();
            }
            if (((String)mca.get("NOMBRE_CONCEPTO")).compareTo("IRPF")==0){
                MovtoIrpf mirpf = dataManager.create(MovtoIrpf.class);
                mirpf.setFecha(fechaFactura);
                mirpf.setAsiento(a);
                mirpf.setNumFra((String) m.get("NOMBRE_EMISOR") + " " + (String)m.get("NUM_FRA"));
                mirpf.setNombre((String) m.get("NOMBRE_EMISOR"));
                mirpf.setNif((String)m.get("NIF_EMISOR"));
                mirpf.setSubclave(SubclaveIrpf.RET_REND_TRAB_PROF);
                mirpf.setBase(((Number) mca.get("BASE_CONCEPTO")).doubleValue());
                if (!mca.containsKey("PORCENTAJE_CONCEPTO")){
                    mirpf.setTipoPorcentaje(0.0);
                }else{
                    mirpf.setTipoPorcentaje(((Number) mca.get("PORCENTAJE_CONCEPTO")).doubleValue());
                }

                mirpf.setCuota(((Number) mca.get("IMPORTE_APLICADO")).doubleValue());
                mirpf.setFechaDeclIrpf(mirpf.getFecha());
                a.getMovtosIrpf().add(mirpf);
                sumaIrpf += mirpf.getCuota();
            }

        }
        //contabilizando los apuntes de iva e irpf en el asiento
        if (sumaIva!=0.0){
            Apunte ap = dataManager.create(Apunte.class);
            String codigoCC = "47200000";
            CuentaContable cc = saldosBean.getCuentaContableDesdeCodigoYPlanContable(codigoCC, pc);
            ap.setCuentaContable(cc);
            ap.setAsiento(a);
            ap.setAmpliacion(ampl);
            ap.setImporte(sumaIva);
            ap.setDebeHaber(true);
            ap.setConceptoApunte(conceptoApunteBean.devuelveConceptoApunteDesdeCodigo("081"));
            ap.setNumApunte(apuntes.size()+1);
            apuntes.add(ap);
        }
        if (sumaIrpf!=0.0){
            Apunte ap = dataManager.create(Apunte.class);
            String codigoCC = "47510000";
            CuentaContable cc = saldosBean.getCuentaContableDesdeCodigoYPlanContable(codigoCC, pc);
            ap.setCuentaContable(cc);
            ap.setAsiento(a);
            ap.setAmpliacion(ampl);
            ap.setImporte(sumaIrpf);
            ap.setDebeHaber(false);
            ap.setConceptoApunte(conceptoApunteBean.devuelveConceptoApunteDesdeCodigo("081"));
            ap.setNumApunte(apuntes.size()+1);
            apuntes.add(ap);

        }

        return a;
    }

    private String determinaSufijoPara(String ubicacion, String departamento, PlanContable pc) throws Exception{
        if (ubicacion.compareTo("ASM")==0){
            if (departamento.compareTo("CASA24")==0){
                ubicacion += "_GUADALEST";
            }
            if (departamento.compareTo("CASA27")==0){
                ubicacion += "_MARVALLOS";
            }
        }
        if (!this.sufijosCCInitialized){
            this.initSufijosCC();
        }
        return sufijosCC.get(ubicacion);
    }

}