package contabilidad.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.JmixProperty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_APUNTE")
@Entity(name = "contabi_Apunte")
public class Apunte {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "AMPLIACION")
    private String ampliacion;

    @Column(name = "IMPORTE", nullable = false)
    @NotNull
    private Double importe;

    @Column(name = "DEBE_HABER", nullable = false)
    @NotNull
    private Boolean debeHaber = false;

    @OnDeleteInverse(DeletePolicy.DENY)
    @JoinColumn(name = "CUENTA_CONTABLE_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private CuentaContable cuentaContable;

    @OnDeleteInverse(DeletePolicy.UNLINK)
    @JoinColumn(name = "ASIENTO_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Asiento asiento;

    @Column(name = "NUM_APUNTE", nullable = false)
    @NotNull
    private Integer numApunte;

    @JoinColumn(name = "CONCEPTO_APUNTE")
    @ManyToOne(fetch = FetchType.LAZY)
    private ConceptoApunte conceptoApunte;

    @Transient
    @JmixProperty
    public String getDebeHaberStr() {
        if (debeHaber==null){
            return "N/A";
        }
        if (debeHaber){
            return "D";
        }else{
            return "H";
        }
    }

    public void setConceptoApunte(ConceptoApunte conceptoApunte) {
        this.conceptoApunte = conceptoApunte;
    }

    public ConceptoApunte getConceptoApunte() {
        return conceptoApunte;
    }

    public Integer getNumApunte() {
        return numApunte;
    }

    public void setNumApunte(Integer numApunte) {
        this.numApunte = numApunte;
    }

    public String getAmpliacion() {
        return ampliacion;
    }

    public void setAmpliacion(String ampliacion) {
        this.ampliacion = ampliacion;
    }

    public Asiento getAsiento() {
        return asiento;
    }

    public void setAsiento(Asiento asiento) {
        this.asiento = asiento;
    }

    public CuentaContable getCuentaContable() {
        return cuentaContable;
    }

    public void setCuentaContable(CuentaContable cuentaContable) {
        this.cuentaContable = cuentaContable;
    }

    public Boolean getDebeHaber() {
        return debeHaber;
    }

    public void setDebeHaber(Boolean debeHaber) {
        this.debeHaber = debeHaber;
    }

    public Double getImporte() {
        return importe;
    }

    public void setImporte(Double importe) {
        this.importe = importe;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }


}