package contabilidad.entity;

import contabilidad.entity.validation.asiento.AsientoValidation;
import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.validation.group.UiCrossFieldChecks;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.groups.Default;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_ASIENTO")
@Entity(name = "contabi_Asiento")
@AsientoValidation(groups = {Default.class, UiCrossFieldChecks.class})
public class Asiento {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @OneToMany(mappedBy = "asiento")
    private List<PointerArchivoAdjuntoExtDoc> pointersArchivosAdjuntosExtDoc;

    @Column(name = "NUM_ASIENTO", nullable = false)
    @NotNull
    private Integer numAsiento;

    @Column(name = "FECHA")
    @Temporal(TemporalType.DATE)
    private Date fecha;

    @Column(name = "FECHA_REGISTRO", nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    @NotNull
    private Date fechaRegistro = new Date();

    @Lob
    @Column(name = "DESCRIPCION")
    private String descripcion;

    @OnDeleteInverse(DeletePolicy.DENY)
    @JoinColumn(name = "EJERCICIO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Ejercicio ejercicio;

    @OneToMany(mappedBy = "asiento")
    private List<MovtoIva> movtosIva;

    @OneToMany(mappedBy = "asiento")
    private List<MovtoIrpf> movtosIrpf;

    @OneToMany(mappedBy = "asiento")
    private List<Apunte> apuntes = new ArrayList<Apunte>();

    @Column(name = "FUENTE", length = 25)
    private String fuente;

    @OneToMany(mappedBy = "asiento")
    private List<ImputacionCentroDeCoste> imputacionesCentroDeCoste = new ArrayList<>();

    public List<ImputacionCentroDeCoste> getImputacionesCentroDeCoste() {
        return imputacionesCentroDeCoste;
    }

    public void setImputacionesCentroDeCoste(List<ImputacionCentroDeCoste> imputacionesCentroDeCoste) {
        this.imputacionesCentroDeCoste = imputacionesCentroDeCoste;
    }

    public String getFuente() {
        return fuente;
    }

    public void setFuente(String fuente) {
        this.fuente = fuente;
    }

    public List<PointerArchivoAdjuntoExtDoc> getPointersArchivosAdjuntosExtDoc() {
        return pointersArchivosAdjuntosExtDoc;
    }

    public void setPointersArchivosAdjuntosExtDoc(List<PointerArchivoAdjuntoExtDoc> pointersArchivosAdjuntosExtDoc) {
        this.pointersArchivosAdjuntosExtDoc = pointersArchivosAdjuntosExtDoc;
    }

    public void setApuntes(List<Apunte> apuntes) {
        this.apuntes = apuntes;
    }

    public List<Apunte> getApuntes() {
        return apuntes;
    }

    public List<MovtoIrpf> getMovtosIrpf() {
        return movtosIrpf;
    }

    public void setMovtosIrpf(List<MovtoIrpf> movtosIrpf) {
        this.movtosIrpf = movtosIrpf;
    }

    public List<MovtoIva> getMovtosIva() {
        return movtosIva;
    }

    public void setMovtosIva(List<MovtoIva> movtosIva) {
        this.movtosIva = movtosIva;
    }

    public Ejercicio getEjercicio() {
        return ejercicio;
    }

    public void setEjercicio(Ejercicio ejercicio) {
        this.ejercicio = ejercicio;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public Date getFechaRegistro() {
        return fechaRegistro;
    }

    public void setFechaRegistro(Date fechaRegistro) {
        this.fechaRegistro = fechaRegistro;
    }

    public Date getFecha() {
        return fecha;
    }

    public void setFecha(Date fecha) {
        this.fecha = fecha;
    }

    public Integer getNumAsiento() {
        return numAsiento;
    }

    public void setNumAsiento(Integer numAsiento) {
        this.numAsiento = numAsiento;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}