package contabilidad.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_CENTRO_DE_COSTE")
@Entity(name = "contabi_CentroDeCoste")
public class CentroDeCoste {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "NOMBRE")
    private String nombre;

    @Column(name = "DESCRIPCION")
    private String descripcion;

    @JoinColumn(name = "CENTRO_DE_COSTE_ANTECESOR_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private CentroDeCoste centroDeCosteAntecesor;

    @OneToMany(mappedBy = "centroDeCosteAntecesor")
    private List<CentroDeCoste> descendientes;
    @OneToOne(fetch = FetchType.LAZY, mappedBy = "centroDeCosteRoot")
    private PlanContable planContable;

    public PlanContable getPlanContable() {
        return planContable;
    }

    public void setPlanContable(PlanContable planContable) {
        this.planContable = planContable;
    }

    public List<CentroDeCoste> getDescendientes() {
        return descendientes;
    }

    public void setDescendientes(List<CentroDeCoste> descendientes) {
        this.descendientes = descendientes;
    }

    public CentroDeCoste getCentroDeCosteAntecesor() {
        return centroDeCosteAntecesor;
    }

    public void setCentroDeCosteAntecesor(CentroDeCoste centroDeCosteAntecesor) {
        this.centroDeCosteAntecesor = centroDeCosteAntecesor;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}