package contabilidad.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.JmixProperty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_EJERCICIO")
@Entity(name = "contabi_Ejercicio")
public class Ejercicio {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "ANNO", nullable = false)
    @NotNull
    private Integer anno;

    @Column(name = "FECHA_INICIO")
    @Temporal(TemporalType.DATE)
    private Date fechaInicio;

    @Column(name = "FECHA_FIN")
    @Temporal(TemporalType.DATE)
    private Date fechaFin;

    @JoinColumn(name = "EMPRESA_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Empresa empresa;

    @OnDeleteInverse(DeletePolicy.DENY)
    @JoinColumn(name = "PLAN_CONTABLE_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private PlanContable planContable;

    @Column(name = "BLOQUEADO")
    private Boolean bloqueado;

    public Boolean getBloqueado() {
        return bloqueado;
    }

    public void setBloqueado(Boolean bloqueado) {
        this.bloqueado = bloqueado;
    }

    @DependsOnProperties({"anno", "empresa"})
    @Transient
    @JmixProperty
    public String getDescriptivo() {
        if ((getEmpresa()!=null) && (getAnno()!=null)){
            return getEmpresa().getNombre() + " " + getAnno().toString();
        }
        return "";
    }

    public PlanContable getPlanContable() {
        return planContable;
    }

    public void setPlanContable(PlanContable planContable) {
        this.planContable = planContable;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public Date getFechaFin() {
        return fechaFin;
    }

    public void setFechaFin(Date fechaFin) {
        this.fechaFin = fechaFin;
    }

    public Date getFechaInicio() {
        return fechaInicio;
    }

    public void setFechaInicio(Date fechaInicio) {
        this.fechaInicio = fechaInicio;
    }

    public Integer getAnno() {
        return anno;
    }

    public void setAnno(Integer anno) {
        this.anno = anno;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}