package contabilidad.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_EMPRESA")
@Entity(name = "contabi_Empresa")
public class Empresa {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "NOMBRE", nullable = false)
    @NotNull
    private String nombre;

    @Column(name = "CIF", nullable = false, unique = true, length = 25)
    @NotNull
    private String cif;

    @Column(name = "DIRECCION1", nullable = false)
    @NotNull
    private String direccion1;

    @Column(name = "DIRECCION2", nullable = false)
    @NotNull
    private String direccion2;

    @Column(name = "FECHA_ALTA", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date fechaAlta;

    @NotNull
    @Column(name = "RAZON_SOCIAL", nullable = false)
    private String razonSocial;

    @OneToMany(mappedBy = "empresa")
    private List<Ejercicio> ejercicio;

    public List<Ejercicio> getEjercicio() {
        return ejercicio;
    }

    public void setEjercicio(List<Ejercicio> ejercicio) {
        this.ejercicio = ejercicio;
    }

    public String getRazonSocial() {
        return razonSocial;
    }

    public void setRazonSocial(String razonSocial) {
        this.razonSocial = razonSocial;
    }

    public Date getFechaAlta() {
        return fechaAlta;
    }

    public void setFechaAlta(Date fechaAlta) {
        this.fechaAlta = fechaAlta;
    }

    public String getDireccion2() {
        return direccion2;
    }

    public void setDireccion2(String direccion2) {
        this.direccion2 = direccion2;
    }

    public String getDireccion1() {
        return direccion1;
    }

    public void setDireccion1(String direccion1) {
        this.direccion1 = direccion1;
    }

    public String getCif() {
        return cif;
    }

    public void setCif(String cif) {
        this.cif = cif;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}