package contabilidad.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_MOVTO_IRPF")
@Entity(name = "contabi_MovtoIrpf")
public class MovtoIrpf {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "NIF", length = 30)
    private String nif;

    @Column(name = "NOMBRE")
    private String nombre;

    @Column(name = "FECHA", nullable = false)
    @Temporal(TemporalType.DATE)
    @NotNull
    private Date fecha;

    @Column(name = "FECHA_DECL_IRPF")
    @Temporal(TemporalType.DATE)
    private Date fechaDeclIrpf;

    @Column(name = "NUM_FRA", length = 50)
    private String numFra;

    @Column(name = "BASE_", nullable = false)
    @NotNull
    private Double base;

    @Column(name = "TIPO_PORCENTAJE", nullable = false)
    @NotNull
    private Double tipoPorcentaje;

    @Column(name = "CUOTA", nullable = false)
    @NotNull
    private Double cuota;

    @Column(name = "SUBCLAVE")
    private String subclave;

    @OnDeleteInverse(DeletePolicy.UNLINK)
    @JoinColumn(name = "ASIENTO_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Asiento asiento;

    public Date getFechaDeclIrpf() {
        return fechaDeclIrpf;
    }

    public void setFechaDeclIrpf(Date fechaDeclIrpf) {
        this.fechaDeclIrpf = fechaDeclIrpf;
    }

    public void setSubclave(SubclaveIrpf subclave) {
        this.subclave = subclave == null ? null : subclave.getId();
    }

    public SubclaveIrpf getSubclave() {
        return subclave == null ? null : SubclaveIrpf.fromId(subclave);
    }

    public Asiento getAsiento() {
        return asiento;
    }

    public void setAsiento(Asiento asiento) {
        this.asiento = asiento;
    }

    public Double getCuota() {
        return cuota;
    }

    public void setCuota(Double cuota) {
        this.cuota = cuota;
    }

    public Double getTipoPorcentaje() {
        return tipoPorcentaje;
    }

    public void setTipoPorcentaje(Double tipoPorcentaje) {
        this.tipoPorcentaje = tipoPorcentaje;
    }

    public Double getBase() {
        return base;
    }

    public void setBase(Double base) {
        this.base = base;
    }

    public String getNumFra() {
        return numFra;
    }

    public void setNumFra(String numFra) {
        this.numFra = numFra;
    }

    public Date getFecha() {
        return fecha;
    }

    public void setFecha(Date fecha) {
        this.fecha = fecha;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getNif() {
        return nif;
    }

    public void setNif(String nif) {
        this.nif = nif;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}