package contabilidad.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_MOVTO_IVA")
@Entity(name = "contabi_MovtoIva")
public class MovtoIva {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @NotNull
    @Column(name = "NIF", nullable = false, length = 30)
    private String nif;

    @Column(name = "NOMBRE", nullable = false)
    @NotNull
    private String nombre;

    @NotNull
    @Column(name = "FECHA", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date fechaDeclIva;

    @Column(name = "FECHA_DE_FACTURA")
    @Temporal(TemporalType.DATE)
    private Date fechaDeFactura;

    @NotNull
    @Column(name = "NUM_FRA", nullable = false, length = 50)
    private String numFra;

    @Column(name = "IMPORTE_BASE", nullable = false)
    @NotNull
    private Double importeBase;

    @Column(name = "TIPO_PORCENTAJE", nullable = false)
    @NotNull
    private Double tipoPorcentaje;

    @Column(name = "CUOTA", nullable = false)
    @NotNull
    private Double cuota;

    @Column(name = "TIPO_MOVTO")
    private String tipoMovto;

    @OnDeleteInverse(DeletePolicy.UNLINK)
    @JoinColumn(name = "ASIENTO_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Asiento asiento;

    public void setTipoMovto(TipoMovtoIva tipoMovto) {
        this.tipoMovto = tipoMovto == null ? null : tipoMovto.getId();
    }

    public TipoMovtoIva getTipoMovto() {
        return tipoMovto == null ? null : TipoMovtoIva.fromId(tipoMovto);
    }

    public Date getFechaDeFactura() {
        return fechaDeFactura;
    }

    public void setFechaDeFactura(Date fechaDeFactura) {
        this.fechaDeFactura = fechaDeFactura;
    }

    public Asiento getAsiento() {
        return asiento;
    }

    public void setAsiento(Asiento asiento) {
        this.asiento = asiento;
    }

    public Double getCuota() {
        return cuota;
    }

    public void setCuota(Double cuota) {
        this.cuota = cuota;
    }

    public Double getTipoPorcentaje() {
        return tipoPorcentaje;
    }

    public void setTipoPorcentaje(Double tipoPorcentaje) {
        this.tipoPorcentaje = tipoPorcentaje;
    }

    public Double getImporteBase() {
        return importeBase;
    }

    public void setImporteBase(Double importeBase) {
        this.importeBase = importeBase;
    }

    public String getNumFra() {
        return numFra;
    }

    public void setNumFra(String numFra) {
        this.numFra = numFra;
    }

    public Date getFechaDeclIva() {
        return fechaDeclIva;
    }

    public void setFechaDeclIva(Date fechaDeclIva) {
        this.fechaDeclIva = fechaDeclIva;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getNif() {
        return nif;
    }

    public void setNif(String nif) {
        this.nif = nif;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}