package contabilidad.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_PLAN_CONTABLE")
@Entity(name = "contabi_PlanContable")
public class PlanContable {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @NotNull
    @Column(name = "TIPO", nullable = false)
    private String tipo;

    @Column(name = "PROFUNDIDAD", nullable = false)
    @NotNull
    private Integer profundidad;

    @Column(name = "NOMBRE", nullable = false)
    @NotNull
    private String nombre;

    @Column(name = "DESCRIPCION")
    private String descripcion;

    @OneToMany(mappedBy = "planContable")
    private List<Ejercicio> ejercicio;

    @JoinColumn(name = "EMPRESA_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Empresa empresa;

    @JoinColumn(name = "CENTRO_DE_COSTE_ROOT_ID")
    @OneToOne(fetch = FetchType.LAZY)
    private CentroDeCoste centroDeCosteRoot;

    public CentroDeCoste getCentroDeCosteRoot() {
        return centroDeCosteRoot;
    }

    public void setCentroDeCosteRoot(CentroDeCoste centroDeCosteRoot) {
        this.centroDeCosteRoot = centroDeCosteRoot;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public List<Ejercicio> getEjercicio() {
        return ejercicio;
    }

    public void setEjercicio(List<Ejercicio> ejercicio) {
        this.ejercicio = ejercicio;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public Integer getProfundidad() {
        return profundidad;
    }

    public void setProfundidad(Integer profundidad) {
        this.profundidad = profundidad;
    }

    public String getTipo() {
        return tipo;
    }

    public void setTipo(String tipo) {
        this.tipo = tipo;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}