package contabilidad.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.entity.annotation.SystemLevel;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.JmixProperty;

import javax.persistence.*;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_POINTER_ARCHIVO_ADJUNT")
@Entity(name = "contabi_PointerArchivoAdjuntoExtDoc")
public class PointerArchivoAdjuntoExtDoc {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @OnDeleteInverse(DeletePolicy.UNLINK)
    @JoinColumn(name = "ASIENTO_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Asiento asiento;

    @SystemLevel
    @Column(name = "ARCHIVO_ADJUNTO_EXT_DOC_ID")
    private Integer archivoAdjuntoExtDocId;

    @DependsOnProperties({"archivoAdjuntoExtDocId"})
    @JmixProperty
    @Transient
    private ArchivoAdjuntoExtDocs archivoAdjuntoExtDoc;

    public ArchivoAdjuntoExtDocs getArchivoAdjuntoExtDoc() {
        return archivoAdjuntoExtDoc;
    }

    public void setArchivoAdjuntoExtDoc(ArchivoAdjuntoExtDocs archivoAdjuntoExtDoc) {
        this.archivoAdjuntoExtDoc = archivoAdjuntoExtDoc;
    }

    public Integer getArchivoAdjuntoExtDocId() {
        return archivoAdjuntoExtDocId;
    }

    public void setArchivoAdjuntoExtDocId(Integer archivoAdjuntoExtDocId) {
        this.archivoAdjuntoExtDocId = archivoAdjuntoExtDocId;
    }

    public Asiento getAsiento() {
        return asiento;
    }

    public void setAsiento(Asiento asiento) {
        this.asiento = asiento;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}