package contabilidad.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.NumberFormat;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@JmixEntity
@Table(name = "CONTABI_SALDO_CUENTA_EJERCICIO")
@Entity(name = "contabi_SaldoCuentaEjercicio")
public class SaldoCuentaEjercicio {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @OnDeleteInverse(DeletePolicy.DENY)
    @JoinColumn(name = "CUENTA_CONTABLE_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private CuentaContable cuentaContable;

    @OnDeleteInverse(DeletePolicy.DENY)
    @JoinColumn(name = "EJERCICIO_ID", nullable = false)
    @NotNull
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Ejercicio ejercicio;

    @NotNull
    @Column(name = "SALDO_INICIAL_DEUDOR_ACREEDOR", nullable = false)
    private Double saldoInicialDeudor;

    @Column(name = "SALDO_INICIAL_ACREEDOR")
    private Double saldoInicialAcreedor;

    @NumberFormat(pattern = "#,#00.00")
    @Column(name = "SALDO_FINAL")
    private Double saldoFinal;

    @NumberFormat(pattern = "#,##0.00")
    @Column(name = "SALDO_INICIAL_PRE_APERTURA")
    private Double saldoInicialPreApertura;

    @NumberFormat(pattern = "#,##0.00")
    @Column(name = "SALDO_FINAL_POST_CIERRE")
    private Double saldoFinalPostCierre;

    public Double getSaldoInicialAcreedor() {
        return saldoInicialAcreedor;
    }

    public void setSaldoInicialAcreedor(Double saldoInicialAcreedor) {
        this.saldoInicialAcreedor = saldoInicialAcreedor;
    }

    public void setSaldoInicialDeudor(Double saldoInicialDeudor) {
        this.saldoInicialDeudor = saldoInicialDeudor;
    }

    public Double getSaldoInicialDeudor() {
        return saldoInicialDeudor;
    }

    public Double getSaldoFinalPostCierre() {
        return saldoFinalPostCierre;
    }

    public void setSaldoFinalPostCierre(Double saldoFinalPostCierre) {
        this.saldoFinalPostCierre = saldoFinalPostCierre;
    }

    public Double getSaldoInicialPreApertura() {
        return saldoInicialPreApertura;
    }

    public void setSaldoInicialPreApertura(Double saldoInicialPreApertura) {
        this.saldoInicialPreApertura = saldoInicialPreApertura;
    }

    public Double getSaldoFinal() {
        return saldoFinal;
    }

    public void setSaldoFinal(Double saldoFinal) {
        this.saldoFinal = saldoFinal;
    }

    public Ejercicio getEjercicio() {
        return ejercicio;
    }

    public void setEjercicio(Ejercicio ejercicio) {
        this.ejercicio = ejercicio;
    }

    public CuentaContable getCuentaContable() {
        return cuentaContable;
    }

    public void setCuentaContable(CuentaContable cuentaContable) {
        this.cuentaContable = cuentaContable;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}