package contabilidad.screen.apunte;

import contabilidad.entity.Asiento;
import io.jmix.ui.Notifications;
import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.DataGrid;
import io.jmix.ui.screen.*;
import contabilidad.entity.Apunte;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("contabi_Apunte.browse")
@UiDescriptor("apunte-browse.xml")
@LookupComponent("apuntesTable")
public class ApunteBrowse extends StandardLookup<Apunte> {

    @Autowired
    private Button btnVerAsiento;
    @Autowired
    private DataGrid<Apunte> apuntesTable;
    @Autowired
    private Notifications notifications;
    @Autowired
    private ScreenBuilders screenBuilders;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        btnVerAsiento.addClickListener(e->{
           Apunte ap =  apuntesTable.getSingleSelected();
           if (ap==null){
               notifications.create().withCaption("Seleccionar apunte").show();
               return;
           }
           Asiento a = ap.getAsiento();
           Screen s = screenBuilders.editor(Asiento.class, this).editEntity(a).withScreenId("contabi_Asiento.edit").withOpenMode(OpenMode.NEW_TAB)
                   .build();
           s.show();

        });
    }


}