package contabilidad.screen.archivoadjuntoextdocs;

import io.jmix.ui.component.Button;
import io.jmix.ui.component.FileUploadField;
import io.jmix.ui.component.UploadField;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.*;
import contabilidad.entity.ArchivoAdjuntoExtDocs;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Base64;

@UiController("contabi_ArchivoAdjuntoExtDocs.edit")
@UiDescriptor("archivo-adjunto-ext-docs-edit.xml")
@EditedEntityContainer("archivoAdjuntoExtDocsDc")
public class ArchivoAdjuntoExtDocsEdit extends StandardEditor<ArchivoAdjuntoExtDocs> {

    boolean fileChanged = false;

    @Autowired
    private FileUploadField representacionSerialField;
    @Autowired
    private InstanceContainer<ArchivoAdjuntoExtDocs> archivoAdjuntoExtDocsDc;

    private ArchivoAdjuntoExtDocs resultadoEditor = null;

    @Subscribe(id = "archivoAdjuntoExtDocsDc", target = Target.DATA_CONTAINER)
    public void onArchivosAdjuntosDcItemPropertyChange(InstanceContainer.ItemPropertyChangeEvent<ArchivoAdjuntoExtDocs> event) {
        if (event.getProperty().compareTo("representacionSerial")==0){
            fileChanged = true;
            byte[] bb = archivoAdjuntoExtDocsDc.getItem().getRepresentacionSerial();
            archivoAdjuntoExtDocsDc.getItem().setTamano(bb.length);


        }



    }

    @Subscribe("representacionSerialField")
    public void onRepresentacionSerialFieldFileUploadFinish(UploadField.FileUploadFinishEvent event) {
        String fn = event.getFileName();
        archivoAdjuntoExtDocsDc.getItem().setNombreArchivo(fn);
        archivoAdjuntoExtDocsDc.getItem().setNombreArchivoOriginal(fn);
        archivoAdjuntoExtDocsDc.getItem().setExtension(fn.substring(fn.lastIndexOf(".")+1));
    }

    public ArchivoAdjuntoExtDocs getUploadedAdjunto(){

        return this.resultadoEditor;
    }

    @Subscribe("closeBtn")
    public void onCloseBtnClick(Button.ClickEvent event) {
        this.resultadoEditor = null;
    }









    @Subscribe
    public void onBeforeCommitChanges(BeforeCommitChangesEvent event) {
        byte[] bb = archivoAdjuntoExtDocsDc.getItem().getRepresentacionSerial();
        bb = Base64.getMimeEncoder().encode(bb);
        bb = Base64.getMimeEncoder().encode(bb);
        archivoAdjuntoExtDocsDc.getItem().setRepresentacionSerial(bb);
        this.resultadoEditor = archivoAdjuntoExtDocsDc.getItem();

    }

}