package contabilidad.screen.asiento;

import contabilidad.beans.AsientoBean;
import contabilidad.beans.SaldosBean;
import contabilidad.beans.Txarh;
import contabilidad.entity.*;
import contabilidad.screen.archivoadjuntoextdocs.ArchivoAdjuntoExtDocsEdit;
import contabilidad.screen.centrodecoste.ImputacionCentroDeCosteEdit;
import io.jmix.core.DataManager;
import io.jmix.core.EntityStates;
import io.jmix.core.LoadContext;
import io.jmix.core.security.CurrentAuthentication;
import io.jmix.ui.Dialogs;
import io.jmix.ui.Notifications;
import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.UiComponents;
import io.jmix.ui.action.DialogAction;
import io.jmix.ui.component.*;
import io.jmix.ui.component.data.ValueSource;
import io.jmix.ui.component.data.value.ContainerValueSource;
import io.jmix.ui.component.impl.ComboBoxImpl;
import io.jmix.ui.component.impl.TextFieldImpl;
import io.jmix.ui.download.Downloader;
import io.jmix.ui.executor.BackgroundTask;
import io.jmix.ui.executor.BackgroundTaskHandler;
import io.jmix.ui.executor.BackgroundWorker;
import io.jmix.ui.executor.TaskLifeCycle;
import io.jmix.ui.model.*;
import io.jmix.ui.model.impl.CollectionPropertyContainerImpl;
import io.jmix.ui.screen.*;

import io.jmix.ui.util.FailedOperationResult;
import io.jmix.ui.util.OperationResult;
import io.jmix.ui.util.SuccessOperationResult;
import io.jmix.ui.widget.JmixGrid;
import org.apache.commons.lang3.StringUtils;
import org.docx4j.wml.Numbering;
import org.springframework.beans.factory.annotation.Autowired;
import io.jmix.ui.component.ComboBox;

import javax.annotation.Nullable;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.TimeUnit;

@UiController("contabi_Asiento.edit2")
@UiDescriptor("asiento-edit2.xml")
@EditedEntityContainer("asientoDc")
@MultipleOpen
@PrimaryEditorScreen(Asiento.class)
public class AsientoEdit2 extends StandardEditor<Asiento> {

    @Autowired
    private Button guardarYNuevo;
    @Autowired
    private UiComponents uiComponents;
    @Autowired
    private DataGrid<ApunteDTO> apuntesTable;
    @Autowired
    private DataGrid<MovtoIva> movtoIvasTable;
    @Autowired
    private DataGrid<MovtoIrpf> movtoIrpfsTable;
    @Autowired
    private DataContext dataContext;

    @Autowired
    private Button btnVerAdjunto;
    @Autowired
    private InstanceContainer<Asiento> asientoDc;
    @Autowired
    private CollectionContainer<MovtoIva> movtoIvasDc;
    @Autowired
    private CollectionContainer<MovtoIrpf> movtoIrpfsDc;
    @Autowired
    private EntityStates entityStates;



    @Autowired
    private DataManager dataManager;
    @Autowired
    private Notifications notifications;
    @Autowired
    private Dialogs dialogs;
    @Autowired
    private AsientoBean asientoBean;
    @Autowired
    private TextField<Integer> numAsientoField;
    @Autowired
    private CurrentAuthentication currentAuthentication;

    @Autowired
    private CollectionContainer<ApunteDTO> apuntesDtoDc;
    @Autowired
    private Button duplicarAsientoBtn;
    @Autowired
    private ScreenBuilders screenBuilders;
    @Autowired
    private Txarh txarh;

    NumberFormat percent = NumberFormat.getPercentInstance();
    @Autowired
    private Button btnNuevoTitular;
    @Autowired
    private Button btnNuevoTitular2;
    @Autowired
    private CollectionLoader<ApunteDTO> apuntesDtoDl;

    private String ultimaAmpliacionRegistrada = "";
    private ConceptoApunte ultimoConceptoApunteRegistrado = null;

    @Autowired
    private DateField<Date> fechaField;
    @Autowired
    private CollectionPropertyContainer<PointerArchivoAdjuntoExtDoc> pointersArchivosAdjuntosExtDocDc;
    @Autowired
    private DataGrid<PointerArchivoAdjuntoExtDoc> archivosAdjuntosTable;

    @Autowired
    Downloader downloader;
    @Autowired
    private DataGrid<ImputacionCentroDeCoste> imputacionesTable;
    @Autowired
    private CollectionPropertyContainer<ImputacionCentroDeCoste> imputacionesDc;
    @Autowired
    private SaldosBean saldosBean;

    @Subscribe
    public void onAfterInit(AfterInitEvent event) {
        apuntesTable.setEditorEnabled(true);
        movtoIrpfsTable.setEditorEnabled(true);
        movtoIvasTable.setEditorEnabled(true);
        imputacionesTable.setEditorEnabled(false);

        duplicarAsientoBtn.addClickListener(e->{
            try {
                Asiento a = asientoBean.duplicarAsiento(this.getEditedEntity());
                screenBuilders.editor(Asiento.class, this).editEntity(a).withScreenId("contabi_Asiento.edit")
                        .withOpenMode(OpenMode.NEW_TAB).build().show();
            } catch (Exception ex) {
                notifications.create().withCaption("Error").withDescription(ex.getMessage()).show();
                return;
            }
        });

        btnNuevoTitular.addClickListener(e->{
            screenBuilders.editor(Titular.class, this).newEntity().withOpenMode(OpenMode.DIALOG)
                    .build().show();
        });
        btnNuevoTitular2.addClickListener(e->{
            screenBuilders.editor(Titular.class, this).newEntity().withOpenMode(OpenMode.DIALOG)
                    .build().show();
        });
    }

    @Autowired
    private BackgroundWorker backgroundWorker;

    protected void updateSaldos(double[] saldos, CuentaContable cc){
        double saldo = saldos[0] - saldos[1];
        String saldoStr = "";
        DecimalFormat df = new DecimalFormat("#,##0.00");
        if (saldo>0){
            saldoStr = df.format(saldo) + " D";
        }else{
            saldoStr = df.format(Math.abs(saldo)) + " H";
        }
        List<ApunteDTO> aps = apuntesDtoDc.getMutableItems();
        for (int i = 0; i < aps.size(); i++) {
            ApunteDTO apdto = aps.get(i);

            if (apdto.getCuentaContable().getCodigo().compareTo(cc.getCodigo())==0){
                apdto.setSaldoStr(saldoStr);
            }
        }
    }

    @Subscribe
    public void onInit(InitEvent event) {

        DataGrid.Column col = apuntesTable.addGeneratedColumn("saldoStr", e->{
            ApunteDTO ap = e.getItem();
            return ap.getSaldoStr();
        });

        col.setEditFieldGenerator(context->{
            TextField tf = uiComponents.create(TextField.NAME);
            tf.setEnabled(false);
            tf.setValueSource((ValueSource<ConceptoApunte>) ((DataGrid.EditorFieldGenerationContext)context).getValueSourceProvider().getValueSource("saldoStr"));
            return tf;
        });

        col = apuntesTable.addGeneratedColumn("cuentaContable", e->{
            ApunteDTO ap = e.getItem();
            if (ap.getCuentaContable() == null) return "";
            return ap.getCuentaContable().getCodigo() + " " + ap.getCuentaContable().getNombre();
        });
        col.setEditFieldGenerator(context->{
            ComboBox<CuentaContable> lookup = uiComponents.create(ComboBox.NAME);
            lookup.setPopupWidth("500px");
            lookup.setPageLength(10);
            lookup.setOptionCaptionProvider(AsientoEdit2::getCaption);
            lookup.setOptionsList(getCuentasContables());
            lookup.setFilterMode(HasFilterMode.FilterMode.CONTAINS);
            lookup.setValueSource((ValueSource<CuentaContable>) ((DataGrid.EditorFieldGenerationContext)context).getValueSourceProvider().getValueSource("cuentaContable"));
            lookup.addValueChangeListener(e->{
                BackgroundTask<Integer, Object[]> task = new BackgroundTask<Integer, Object[]>(10, this) {
                    @Override
                    public Object[] run(TaskLifeCycle<Integer> taskLifeCycle) throws Exception {
                        // Do something in background thread
                        CuentaContable cc = e.getValue();
                        double saldo[] = (double[])saldosBean.getSaldosCuentaAFecha(cc, getEditedEntity().getFecha());
                        return new Object[]{cc, saldo};
                    }

                    @Override
                    public void canceled() {
                        // Do something in UI thread if the task is canceled
                    }

                    @Override
                    public void done(Object[] result) {
                        updateSaldos((double[]) result[1], (CuentaContable) result[0]);
                    }

                    @Override
                    public void progress(List<Integer> changes) {
                        // Show current progress in UI thread
                    }
                };
                BackgroundTaskHandler bth = backgroundWorker.handle(task);
                bth.execute();

            });
            return lookup;
        });

        col = apuntesTable.addGeneratedColumn("conceptoApunte", e->{
            ApunteDTO ap = e.getItem();
            if (ap.getConceptoApunte() == null) return "";
            return ap.getConceptoApunte().getCodigo() + " " + ap.getConceptoApunte().getDescripcion();
        });

        col.setEditFieldGenerator(context->{
            ComboBox<ConceptoApunte> lookup = uiComponents.create(ComboBox.NAME);
            lookup.setPopupWidth("500px");
            lookup.setPageLength(20);
            lookup.setOptionCaptionProvider(AsientoEdit2::getCaptionConceptoApunte);
            lookup.setOptionsList(getConceptosApuntes());
            lookup.setFilterMode(HasFilterMode.FilterMode.CONTAINS);
            lookup.setValueSource((ValueSource<ConceptoApunte>) ((DataGrid.EditorFieldGenerationContext)context).getValueSourceProvider().getValueSource("conceptoApunte"));
            return lookup;
        });


        col = movtoIvasTable.addGeneratedColumn("tipoPorcentaje", e->{

            MovtoIva miva = e.getItem();
            if (miva.getTipoPorcentaje()==null){
                miva.setTipoPorcentaje(0.21);
            }
            return miva.getTipoPorcentaje()*100;
        });

        col.setEditFieldGenerator(context->{
            ComboBox<Double> lookup = uiComponents.create(ComboBox.NAME);
            lookup.setPopupWidth("150px");
            lookup.setPageLength(7);
            lookup.setOptionCaptionProvider(AsientoEdit::getCaptionTipoPorcentajeMIVA);
            lookup.setOptionsList(Arrays.asList(new Double[]{0.00,0.04,0.07, 0.10, 0.16,0.21,0.33}));
            lookup.setFilterMode(HasFilterMode.FilterMode.CONTAINS);
            lookup.setValueSource((ValueSource<Double>) ((DataGrid.EditorFieldGenerationContext)context).getValueSourceProvider().getValueSource("tipoPorcentaje"));
            lookup.addValueChangeListener(e->{
                InstanceContainer instanceContainer = ((ContainerValueSource)((ComboBoxImpl)e.getSource()).getValueSource()).getContainer();
                MovtoIva miva = (MovtoIva)instanceContainer.getItem();
                double nuevaCuota = miva.getImporteBase()*e.getValue();
                ((MovtoIva)instanceContainer.getItem()).setCuota(nuevaCuota);
                int y = 2;
            });
            return lookup;
        });

        //movtoirpf
        col = movtoIrpfsTable.addGeneratedColumn("tipoPorcentaje", e->{

            MovtoIrpf mirpf = e.getItem();
            if (mirpf.getTipoPorcentaje() == null){
                mirpf.setTipoPorcentaje(0.15);
            }
            return mirpf.getTipoPorcentaje()*100;
        });

        col.setEditFieldGenerator(context->{
            ComboBox<Double> lookup = uiComponents.create(ComboBox.NAME);
            lookup.setPopupWidth("150px");
            lookup.setPageLength(7);
            lookup.setOptionCaptionProvider(AsientoEdit::getCaptionTipoPorcentajeMIVA);
            lookup.setOptionsList(Arrays.asList(new Double[]{0.00,0.01,0.02, 0.07, 0.15,0.21}));
            lookup.setFilterMode(HasFilterMode.FilterMode.CONTAINS);
            lookup.setValueSource((ValueSource<Double>) ((DataGrid.EditorFieldGenerationContext)context).getValueSourceProvider().getValueSource("tipoPorcentaje"));
            lookup.addValueChangeListener(e->{
                InstanceContainer instanceContainer = ((ContainerValueSource)((ComboBoxImpl)e.getSource()).getValueSource()).getContainer();
                MovtoIrpf mirpf = (MovtoIrpf)instanceContainer.getItem();
                double nuevaCuota = mirpf.getBase()*e.getValue();
                ((MovtoIrpf)instanceContainer.getItem()).setCuota(nuevaCuota);
                int y = 2;
            });
            return lookup;
        });

        col = movtoIvasTable.addGeneratedColumn("nif", e->{
            MovtoIva miva = e.getItem();
            try{
                Titular t = dataManager.load(Titular.class).query("select t from contabi_Titular t where t.nif = :nif")
                        .parameter("nif", miva.getNif()).one();

                return t.getNif();
            }catch(Exception exc){
                return miva.getNif() + " - Titular no hallado";
            }

        });
        col.setEditFieldGenerator(context->{
            ComboBox<String> lookup = uiComponents.create(ComboBox.NAME);
            lookup.setPopupWidth("500px");
            lookup.setPageLength(10);
            lookup.setOptionCaptionProvider(AsientoEdit2::getCaptionTitular);
            lookup.setOptionsList(getTitulares());
            lookup.setFilterMode(HasFilterMode.FilterMode.CONTAINS);
            lookup.setValueSource((ValueSource<String>) ((DataGrid.EditorFieldGenerationContext)context).getValueSourceProvider().getValueSource("nif"));
            lookup.addValueChangeListener(e->{
                MovtoIva miva = (MovtoIva) ((ContainerValueSource)((ComboBoxImpl)e.getComponent()).getValueSource()).getContainer().getItem();
                if (e.isUserOriginated()) {
                    String s = e.getValue();
                    String nif = s.split("-")[0].trim();
                    String nombre = s.split("-")[1].trim();
                    miva.setNif(nif);
                    miva.setNombre(nombre);
                }
                //
//                Titular t = dataManager.load(Titular.class).query("select t from contabi_Titular t where t.nif = :nif")
//                                .parameter("nif", miva.getNif()).one();
//                miva.setNombre(t.getNombre());
//                int y = 2;
            });
            return lookup;
        });


        col = movtoIrpfsTable.addGeneratedColumn("nif", e->{
            MovtoIrpf mirpf = e.getItem();
            try{
                Titular t = dataManager.load(Titular.class).query("select t from contabi_Titular t where t.nif = :nif")
                        .parameter("nif", mirpf.getNif()).one();

                return t.getNif();
            }catch(Exception exc){
                return mirpf.getNif() + " - Titular no hallado";
            }

        });
        col.setEditFieldGenerator(context->{
            ComboBox<String> lookup = uiComponents.create(ComboBox.NAME);
            lookup.setPopupWidth("500px");
            lookup.setPageLength(10);
            lookup.setOptionCaptionProvider(AsientoEdit2::getCaptionTitular);
            lookup.setOptionsList(getTitulares());
            lookup.setFilterMode(HasFilterMode.FilterMode.CONTAINS);
            lookup.setValueSource((ValueSource<String>) ((DataGrid.EditorFieldGenerationContext)context).getValueSourceProvider().getValueSource("nif"));
            lookup.addValueChangeListener(e->{
                MovtoIrpf mirpf = (MovtoIrpf) ((ContainerValueSource)((ComboBoxImpl)e.getComponent()).getValueSource()).getContainer().getItem();
                if (e.isUserOriginated()) {
                    String s = e.getValue();
                    String nif = s.split("-")[0].trim();
                    String nombre = s.split("-")[1].trim();
                    mirpf.setNif(nif);
                    mirpf.setNombre(nombre);
                }

            });
            return lookup;
        });

        apuntesDtoDc.addItemPropertyChangeListener(e->{
           ApunteDTO apdto = e.getItem();
           String property = e.getProperty();
           if (property.compareTo("importeDebe")==0){
               apdto.setImporteHaber(0.0);
           }else if (property.compareTo("importeHaber")==0){
               apdto.setImporteDebe(0.0);
           }
           if (property.compareTo("ampliacion")==0){
               this.ultimaAmpliacionRegistrada = apdto.getAmpliacion();
           }
           if (property.compareTo("conceptoApunte")==0){
               this.ultimoConceptoApunteRegistrado = apdto.getConceptoApunte();
           }
           if (property.compareTo("cuentaContable")==0){
               if((apdto.getAmpliacion()==null)||(apdto.getAmpliacion().trim().length()==0)){
                   apdto.setAmpliacion(this.ultimaAmpliacionRegistrada);
               }
               if ((apdto.getConceptoApunte()==null)){
                   apdto.setConceptoApunte(this.ultimoConceptoApunteRegistrado);
               }
               //si es una cuenta de iva o irpf: generar los apuntes
               if (apdto.getCuentaContable()!=null){
                   if (apdto.getCuentaContable().getCodigo().substring(0,3).compareTo("472")==0){
                       if (asientoDc.getItem().getMovtosIva().size()==0) {
                           MovtoIva miva = dataContext.create(MovtoIva.class);
                           miva.setAsiento(asientoDc.getItem());
                           movtoIvasDc.getMutableItems().add(miva);
                           miva.setFechaDeclIva(new Date());
                           miva.setFechaDeFactura(asientoDc.getItem().getFecha());
                           miva.setTipoPorcentaje(0.21);
                           try {
                               miva.setNumFra(apuntesDtoDc.getMutableItems().get(0).getAmpliacion());
                           } catch (Exception exc) {

                           }
                           miva.setTipoMovto(TipoMovtoIva.REC);
                           miva.setImporteBase(estimaBaseImponibleIvaDeAsiento());
                           miva.setCuota(miva.getImporteBase() * miva.getTipoPorcentaje());
                           apdto.setImporteDebe(miva.getCuota());
                       }
                   }
                   if (apdto.getCuentaContable().getCodigo().substring(0,4).compareTo("4751")==0){
                       if (asientoDc.getItem().getMovtosIrpf().size()==0) {
                           MovtoIrpf mirpf = dataContext.create(MovtoIrpf.class);
                           mirpf.setAsiento(asientoDc.getItem());
                           movtoIrpfsDc.getMutableItems().add(mirpf);
                           mirpf.setFechaDeclIrpf(new Date());
                           mirpf.setFecha(asientoDc.getItem().getFecha());
                           mirpf.setTipoPorcentaje(0.15);
                           try {
                               mirpf.setNumFra(apuntesDtoDc.getMutableItems().get(0).getAmpliacion());
                           } catch (Exception exc) {

                           }
                           mirpf.setSubclave(SubclaveIrpf.RET_REND_TRAB_PROF);
                           mirpf.setBase(estimaBaseIrpfDeAsiento());
                           mirpf.setCuota(mirpf.getBase() * mirpf.getTipoPorcentaje());
                           apdto.setImporteHaber(mirpf.getCuota());
                       }
                   }
               }
           }
        });
    }




    public static String getTxaReportAsiento(List<Asiento> aa, Ejercicio ejActivo, Txarh txarh) throws Exception{
        String s = "";
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy hh:mm");
        SimpleDateFormat sdf2 = new SimpleDateFormat("dd/MM/yyyy");
        DecimalFormat df = new DecimalFormat("#,##0.00");
        Collections.sort(aa, new Comparator<Asiento>() {
            @Override
            public int compare(Asiento o1, Asiento o2) {
                return o1.getNumAsiento().compareTo(o2.getNumAsiento());
            }
        });
        for (int i = 0; i < aa.size(); i++) {
            Asiento a = aa.get(i);
            boolean printHeader = true;
            if (i > 0) printHeader = false;
            if (printHeader) {
                Asiento adesde = aa.get(0);
                Asiento ahasta = aa.get(aa.size()-1);
                //cabeza fecha y hora
                s += txarh.fillNColsFieldWithValue(sdf.format(new Date()), 40) + txarh.breakLine();
                //nombre empresa
                s += txarh.fillNColsFieldWithValue(a.getEjercicio().getEmpresa().getNombre(), 50) + txarh.fillNColsFieldWithValue("(Ejercicio  " + ejActivo.getAnno().toString() + ")", 30, txarh.HORIZONTAL_ALIGNMENT_RIGHT) + txarh.breakLine();
                s += txarh.fillNColsFieldWithValue("Asientos - Comprobación", 30) + txarh.breakLine();
                s += txarh.fillNColsFieldWithValue(StringUtils.repeat("-", 100), 100) + txarh.breakLine();
                s += txarh.fillNColsFieldWithValue("Asientos:", 40) + txarh.fillNColsFieldWithValue("Desde", 10) + txarh.fillNColsFieldWithValue("Hasta", 10) + txarh.breakLine();
                s += txarh.fillNColsFieldWithValue(StringUtils.repeat("-", 100), 100) + txarh.breakLine();
                s += txarh.fillNColsFieldWithValue("Num.Asiento", 40) + txarh.fillNColsFieldWithValue(adesde.getNumAsiento().toString(), 15) + txarh.fillNColsFieldWithValue(ahasta.getNumAsiento().toString(), 15) + txarh.breakLine();
                s += txarh.fillNColsFieldWithValue(StringUtils.repeat("-", 100), 100) + txarh.breakLine();
            }
            s += txarh.breakLine();

            int[] cols1 = new int[]{40, 20};
            int[] cols2 = new int[]{20, //asiento apunte
                    15, //codigo
                    40, //nombre cuenta
                    7, //concepto apunte
                    70,//ampl conc.
                    10, //importe
                    5 //debe haber
            };
            int addupcols1 = cols1[0] + cols1[1];
            int addupcols2 = cols2[0] + cols2[1] + cols2[2] + cols2[3] + cols2[4] + cols2[5];
            //encabezados
            s += txarh.fillNColsFieldWithValue("Fecha", cols1[0]) + txarh.breakLine();
            s += txarh.fillNColsFieldWithValue("Asto/Apte", cols2[0])
                    + txarh.fillNColsFieldWithValue("Codigo", cols2[1])
                    + txarh.fillNColsFieldWithValue("Nombre", cols2[2])
                    + txarh.fillNColsFieldWithValue("Concepto", cols2[3])
                    + txarh.fillNColsFieldWithValue("Ampl.Conc.", cols2[4])
                    + txarh.fillNColsFieldWithValue("Importe", cols2[5])
                    + txarh.fillNColsFieldWithValue("D/H", cols2[6]) + txarh.breakLine();
            s += txarh.fillNColsFieldWithValue(StringUtils.repeat("-",addupcols2),addupcols2) + txarh.breakLine();
            //datos
            s += txarh.fillNColsFieldWithValue(sdf.format(a.getFecha()), cols1[0]) + txarh.breakLine();
            List<Apunte> apuntes = new ArrayList(a.getApuntes());
            Collections.sort(apuntes, txarh.comparatorAps);
            for (int j = 0; j < apuntes.size(); j++) {
                Apunte ap = apuntes.get(j);
                String dh = "D";
                if (ap.getDebeHaber()==false){
                    dh = "H";
                }
                s += txarh.fillNColsFieldWithValue(a.getNumAsiento().toString()+"/"+ap.getNumApunte().toString(), cols2[0])
                        + txarh.fillNColsFieldWithValue(ap.getCuentaContable().getCodigo(), cols2[1])
                        + txarh.fillNColsFieldWithValue(ap.getCuentaContable().getNombre(), cols2[2])
                        + txarh.fillNColsFieldWithValue(ap.getConceptoApunte().getCodigo(), cols2[3])
                        + txarh.fillNColsFieldWithValue(ap.getAmpliacion(), cols2[4])
                        + txarh.fillNColsFieldWithValue(df.format(ap.getImporte()), cols2[5])
                        + txarh.fillNColsFieldWithValue(dh, cols2[6]) + txarh.breakLine();


            }
            s += txarh.fillNColsFieldWithValue(StringUtils.repeat("-",addupcols2),addupcols2) + txarh.breakLine();

        }



        return s;
    }


    public static String getCaptionTipoPorcentajeMIVA(Double d){
        NumberFormat percent = NumberFormat.getPercentInstance();
        return percent.format(d);
    }

    public static String getCaptionTitular(String s){
        return s;
    }

    public static String getCaptionTipoPorcentajeMIRPF(MovtoIrpf mirpf){
        NumberFormat percent = NumberFormat.getPercentInstance();
        return percent.format(mirpf.getTipoPorcentaje());
    }


    public static String getCaption(CuentaContable cc){
        int y = 2;
        return cc.getCodigo() + " " + cc.getNombre();
    }

    public static String getCaptionConceptoApunte(ConceptoApunte ca){
        return ca.getCodigo() + " " + ca.getDescripcion();
    }

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        if (entityStates.isNew(asientoDc.getItem())){

            if ((asientoDc.getItem().getFuente()!=null)&&(asientoDc.getItem().getFuente().compareTo("SOFIA")==0)){
                //no hago nada pues todo se ha poblado en el servicio de construccion de asiento
            }else{
                asientoDc.getItem().setFuente("UI");
                asientoDc.getItem().setMovtosIva(new ArrayList());
                asientoDc.getItem().setMovtosIrpf(new ArrayList());
            }

        }

        if (((User)currentAuthentication.getUser()).getEjercicioActivo()!=null){
            Ejercicio ej = ((User) currentAuthentication.getUser()).getEjercicioActivo();
            if (asientoDc.getItem().getEjercicio()==null){
                asientoDc.getItem().setEjercicio(ej);
            }

        }

        try {
            if (entityStates.isNew(asientoDc.getItem())){
                Integer numAsto = asientoBean.getNuevoNumAsiento(asientoDc.getItem().getEjercicio());
                numAsientoField.setValue(numAsto);
                fechaField.setValue(new Date());
            }

        }catch(Exception exc){
            this.setReadOnly(true);
        }

        apuntesDtoDl.load();

        if (!entityStates.isNew(asientoDc.getItem())){
            ArrayList al = new ArrayList();
            for (int i = 0; i < asientoDc.getItem().getApuntes().size(); i++) {
                CuentaContable cc = asientoDc.getItem().getApuntes().get(i).getCuentaContable();
                if (al.indexOf(cc)==-1){
                    al.add(cc);
                }

            }
            for (int i = 0; i < al.size(); i++) {
                CuentaContable cc = (CuentaContable) al.get(i);
                updateSaldosAsync(cc, asientoDc.getItem().getFecha());
            }

        }




    }

    private void updateSaldosAsync(CuentaContable cc, Date fecha){
        BackgroundTask<Integer, Object[]> task = new BackgroundTask<Integer, Object[]>(10, this) {
            @Override
            public Object[] run(TaskLifeCycle<Integer> taskLifeCycle) throws Exception {

                double saldo[] = (double[])saldosBean.getSaldosCuentaAFecha(cc, getEditedEntity().getFecha());
                return new Object[]{cc, saldo};
            }

            @Override
            public void canceled() {
                // Do something in UI thread if the task is canceled
            }

            @Override
            public void done(Object[] result) {
                updateSaldos((double[]) result[1], (CuentaContable) result[0]);
            }

            @Override
            public void progress(List<Integer> changes) {
                // Show current progress in UI thread
            }
        };
        BackgroundTaskHandler bth = backgroundWorker.handle(task);
        bth.execute();
    }

    private void ajustaDescripcionAsiento(){
        if ((asientoDc.getItem().getDescripcion()==null)||(asientoDc.getItem().getDescripcion().trim().length()==0)){
            ArrayList<String> al = new ArrayList<String>();
            for (int i = 0; i < asientoDc.getItem().getApuntes().size(); i++) {
                String descAp = asientoDc.getItem().getApuntes().get(i).getAmpliacion();
                if (al.indexOf(descAp.trim())==-1){
                    al.add(descAp.trim());
                }
            }
            String s = "";
            for (int i = 0; i < al.size(); i++) {
                if (i>0) s += " - ";
                s += al.get(i);
            }
            asientoDc.getItem().setDescripcion(s);
        }
    }

    @Subscribe("addApteDebe")
    public void onAddApteDebeClick(Button.ClickEvent event) {
        ApunteDTO apDto = new ApunteDTO();
        apDto.setId(UUID.randomUUID());
        apDto.setNumApunte(apuntesDtoDc.getMutableItems().size()+1);
        apuntesDtoDc.getMutableItems().add(apDto);
    }



    @Subscribe("rmvApteDebe")
    public void onRmvApteDebeClick(Button.ClickEvent event) {
        this.cancelDataGridEditors(apuntesTable);
        final ApunteDTO apte = apuntesTable.getSingleSelected();
        if (apte==null){
            notifications.create().withCaption("Seleccionar un apunte").withDescription("Selección nula").show();
            return;
        }else{
            dialogs.createOptionDialog().withCaption("Confirmación").withMessage("¿Desea eliminar el apunte seleccionado")
                    .withActions(
                            new DialogAction(DialogAction.Type.YES).withCaption("Confirmar").withHandler(e->{
                                apuntesDtoDc.getMutableItems().remove(apte);

                                notifications.create().withCaption("Apunte Eliminado").show();
                            }),
                            new DialogAction(DialogAction.Type.NO).withCaption("Cancelar").withHandler(e->{

                            })

                    ).show();

            return;
        }
    }

    @Subscribe("addMovtoIva")
    public void onAddMovtoIvaClick(Button.ClickEvent event) {
        MovtoIva miva = dataContext.create(MovtoIva.class);
        miva.setAsiento(asientoDc.getItem());
        miva.setTipoMovto(TipoMovtoIva.REC);
        movtoIvasDc.getMutableItems().add(miva);
    }

    @Subscribe("rmvMovtoIva")
    public void onRmvMovtoIvaClick(Button.ClickEvent event) {
        final MovtoIva miva = movtoIvasTable.getSingleSelected();
        if (miva==null){
            notifications.create().withCaption("Seleccionar un movimiento de IVA").withDescription("Selección nula").show();
            return;
        }else{
            dialogs.createOptionDialog().withCaption("Confirmación").withMessage("¿Desea eliminar el movimiento seleccionado")
                    .withActions(
                            new DialogAction(DialogAction.Type.YES).withCaption("Confirmar").withHandler(e->{
                                movtoIvasDc.getMutableItems().remove(miva);
                                dataContext.remove(miva);
                                notifications.create().withCaption("Movimiento Eliminado").show();
                            }),
                            new DialogAction(DialogAction.Type.NO).withCaption("Cancelar").withHandler(e->{

                            })

                    ).show();

            return;
        }
    }





    @Subscribe("addMovtoIrpf")
    public void onAddMovtoIrpfClick(Button.ClickEvent event) {
        MovtoIrpf mirpf = dataContext.create(MovtoIrpf.class);
        mirpf.setAsiento(asientoDc.getItem());
        mirpf.setSubclave(SubclaveIrpf.RET_REND_TRAB_PROF);
        movtoIrpfsDc.getMutableItems().add(mirpf);
    }

    @Subscribe("rmvMovtoIrpf")
    public void onRmvMovtoIrpfClick(Button.ClickEvent event) {
        final MovtoIrpf mirpf = movtoIrpfsTable.getSingleSelected();
        if (mirpf==null){
            notifications.create().withCaption("Seleccionar un movimiento de Irpf").withDescription("Selección nula").show();
            return;
        }else{
            dialogs.createOptionDialog().withCaption("Confirmación").withMessage("¿Desea eliminar el apunte seleccionado")
                    .withActions(
                            new DialogAction(DialogAction.Type.YES).withCaption("Confirmar").withHandler(e->{
                                movtoIrpfsDc.getMutableItems().remove(mirpf);
                                dataContext.remove(mirpf);
                                notifications.create().withCaption("Movimiento Eliminado").show();
                            }),
                            new DialogAction(DialogAction.Type.NO).withCaption("Cancelar").withHandler(e->{

                            })

                    ).show();

            return;
        }
    }

    @Install(to = "apuntesDtoDl", target = Target.DATA_LOADER)
    private List<ApunteDTO> apuntesDtoDlLoadDelegate(LoadContext<ApunteDTO> loadContext) {
        if (asientoDc.getItemOrNull()==null){
            return new ArrayList<>();
        }
        List<Apunte> apuntes = asientoDc.getItem().getApuntes();
        //if asiento is a new instance append 5 apuntes not initialized on each side of the asiento structure
        if (entityStates.isNew(asientoDc.getItem())){
            if (apuntes.size()==0) {
                for (int i = 0; i < 5; i++) {
                    Apunte ap = dataContext.create(Apunte.class);
                    ap.setNumApunte((i + 1));
                    ap.setImporte(0.0);
                    ap.setAsiento(asientoDc.getItem());
                    apuntes.add(ap);
                }
            }
        }

        List<ApunteDTO> apsDto = new ArrayList<>();
        for (int i = 0; i < apuntes.size(); i++) {
            Apunte ap = apuntes.get(i);
            ApunteDTO apDto = new ApunteDTO();
            apDto.setId(UUID.randomUUID());
            apDto.setConceptoApunte(ap.getConceptoApunte());
            apDto.setAmpliacion(ap.getAmpliacion());
            apDto.setCuentaContable(ap.getCuentaContable());
            apDto.setNumApunte(ap.getNumApunte());
            if (ap.getDebeHaber()){
                apDto.setImporteDebe(ap.getImporte());
                apDto.setImporteHaber(0.0);
            }else{
                apDto.setImporteDebe(0.0);
                apDto.setImporteHaber(ap.getImporte());
            }
            apsDto.add(apDto);
        }
        Collections.sort(apsDto, new Comparator<ApunteDTO>() {
            @Override
            public int compare(ApunteDTO o1, ApunteDTO o2) {
                return  o1.getNumApunte().compareTo(o2.getNumApunte());
            }
        });
        return apsDto;
    }



    private void ajustaAsientoAntesDeGuardado(){
        limpiaApuntesInterfazAsiento();


        //actualizando el miembro apuntes de asiento
        List<Apunte> apuntes = new ArrayList(asientoDc.getItem().getApuntes());
        for (int i = 0; i < apuntes.size(); i++) {
            dataContext.remove(apuntes.get(i));
        }

        asientoDc.getItem().getApuntes().clear();
        for (int i = 0; i < apuntesDtoDc.getItems().size(); i++) {
            ApunteDTO apDto = apuntesDtoDc.getItems().get(i);
            Apunte ap = dataContext.create(Apunte.class);
            ap.setAsiento(asientoDc.getItem());
            if (apDto.getImporteDebe()>0.0){
                ap.setDebeHaber(true);
                ap.setImporte(apDto.getImporteDebe());
            }
            if(apDto.getImporteHaber()>0.0){
                ap.setDebeHaber(false);
                ap.setImporte(apDto.getImporteHaber());
            }
            if ((apDto.getImporteDebe() == 0.0) && (apDto.getImporteHaber()== 0.0)){
                ap.setDebeHaber(true);
                ap.setImporte(0.0);
            }
            ap.setNumApunte(apDto.getNumApunte());
            ap.setAmpliacion(apDto.getAmpliacion());
            ap.setCuentaContable(apDto.getCuentaContable());
            ap.setConceptoApunte(apDto.getConceptoApunte());
            asientoDc.getItem().getApuntes().add(ap);

        }
        this.getEditedEntity().setApuntes(asientoDc.getItem().getApuntes());
        ajustaDescripcionAsiento();
    }

    @Subscribe("guardarYNuevo")
    public void onGuardarYNuevoClick(Button.ClickEvent event) {
        OperationResult or = this.closeWithCommit();
        if (or instanceof SuccessOperationResult){
            screenBuilders.editor(Asiento.class, this).newEntity().withScreenId("contabi_Asiento.edit2").withOpenMode(OpenMode.NEW_TAB)
                    .build().show();

        }else if (or instanceof FailedOperationResult){
            //no hacemos nada
        }

        return;
    }




    protected OperationResult commitChanges() {
        ajustaAsientoAntesDeGuardado();
        cancelDataGridEditors(apuntesTable);
        return super.commitChanges();

    }




    private void limpiaApuntesInterfazAsiento(){
        //adecuamos la lista de apuntes
        //si un apunte tiene cuenta e importe null lo eliminamos
        List<ApunteDTO> todelete = new ArrayList();
        for (int i = 0; i < apuntesDtoDc.getItems().size(); i++) {
            ApunteDTO ap = apuntesDtoDc.getItems().get(i);
            if (!ap.isValid()){
                todelete.add(ap);
            }
        }
        apuntesDtoDc.getMutableItems().removeAll(todelete);


    }


    private void cancelDataGridEditors(DataGrid dataGrid){
        dataGrid.withUnwrapped(JmixGrid.class, jmixGrid -> {
            jmixGrid.getEditor().cancel();
        });
    }







    public List<CuentaContable> getCuentasContables(){
        String eql = "select cc from contabi_CuentaContable cc join cc.planContable pc where " +
                "pc.id = :pcid order by cc.codigo asc";
        List l = dataManager.load(CuentaContable.class).query(eql)
                .parameter("pcid", ((User) currentAuthentication.getUser()).getEjercicioActivo().getPlanContable().getId() )
                .list();
        return l;
    }

    public List<ConceptoApunte> getConceptosApuntes(){
        String eql = "select ca from contabi_ConceptoApunte ca join ca.planContable pc where " +
                "pc.id = :pcid order by ca.descripcion asc";
        List l = dataManager.load(ConceptoApunte.class).query(eql)
                .parameter("pcid", ((User) currentAuthentication.getUser()).getEjercicioActivo().getPlanContable().getId() )
                .list();
        return l;
    }

    public List<String> getTitulares(){
        String eql = "select t from contabi_Titular t order by t.nombre asc";
        List l = dataManager.load(Titular.class).query(eql)
                .list();
        ArrayList al = new ArrayList();
        for (int i = 0; i < l.size(); i++) {
            Titular t = (Titular)l.get(i);
            al.add(t.getNif() + " - " + t.getNombre());
        }
        return al;
    }

    @Subscribe("btnAdjuntarArchivo")
    public void onBtnAdjuntarArchivoClick(Button.ClickEvent event) {
        Screen s = screenBuilders.editor(ArchivoAdjuntoExtDocs.class, this).newEntity()
                .withOpenMode(OpenMode.DIALOG).build().show();
        s.addAfterCloseListener(e->{
           ArchivoAdjuntoExtDocsEdit s_ = (ArchivoAdjuntoExtDocsEdit)e.getSource();

           ArchivoAdjuntoExtDocs aa = s_.getUploadedAdjunto();
           if (aa!=null){
               PointerArchivoAdjuntoExtDoc p = dataContext.create(PointerArchivoAdjuntoExtDoc.class);
               p.setAsiento(this.getEditedEntity());
               p.setArchivoAdjuntoExtDoc(aa);
               p.setArchivoAdjuntoExtDocId(aa.getId());
               pointersArchivosAdjuntosExtDocDc.getMutableItems().add(p);
           }
        });
    }

    @Subscribe("btnEliminarArchivoAdjunto")
    public void onBtnEliminarArchivoAdjuntoClick(Button.ClickEvent event) {
        PointerArchivoAdjuntoExtDoc p = archivosAdjuntosTable.getSingleSelected();
        if (p==null){
            notifications.create().withDescription("Seleccionar archivo a eliminar de asiento").show();
            return;
        }
        dialogs.createOptionDialog().withCaption("¿Está seguro que desea eliminar esta asociacion con un archivo adjunto?")
                        .withActions(
                                new DialogAction(DialogAction.Type.YES).withHandler(e->{
                                    dataContext.remove(p);
                                    pointersArchivosAdjuntosExtDocDc.getMutableItems().remove(p);
                                }),
                                new DialogAction(DialogAction.Type.NO).withHandler(e->{

                                })

                        ).show();

    }

    @Subscribe("btnVerAdjunto")
    public void onBtnVerAdjuntoClick(Button.ClickEvent event) {
        PointerArchivoAdjuntoExtDoc p = archivosAdjuntosTable.getSingleSelected();
        if (p==null){
            notifications.create().withCaption("Seleccionar un archivo para visualizar").show();
            return;
        }
        ArchivoAdjuntoExtDocs aa = p.getArchivoAdjuntoExtDoc();
        if (aa==null){
            aa = dataManager.load(ArchivoAdjuntoExtDocs.class).id(p.getArchivoAdjuntoExtDocId()).one();

        }
        byte[] bb = aa.getRepresentacionSerial();
        bb = Base64.getMimeDecoder().decode(bb);
        bb = Base64.getMimeDecoder().decode(bb);
        downloader.download(bb, aa.getNombreArchivo());
    }

    @Subscribe(id = "movtoIvasDc", target = Target.DATA_CONTAINER)
    public void onMovtoIvasDcItemPropertyChange(InstanceContainer.ItemPropertyChangeEvent<MovtoIva> event) {
        if (event.getProperty().compareTo("importeBase")==0){
            MovtoIva miva = event.getItem();
            miva.setCuota(miva.getImporteBase() * miva.getTipoPorcentaje());
        }
    }

    @Subscribe(id = "movtoIrpfsDc", target = Target.DATA_CONTAINER)
    public void onMovtoIrpfsDcItemPropertyChange(InstanceContainer.ItemPropertyChangeEvent<MovtoIrpf> event) {
        if (event.getProperty().compareTo("base")==0){
            MovtoIrpf mirpf = event.getItem();
            mirpf.setCuota(mirpf.getBase() * mirpf.getTipoPorcentaje());
        }
    }

    private double estimaBaseImponibleIvaDeAsiento(){
        double estimacion = 0.0;
        List<ApunteDTO> aps = apuntesDtoDc.getMutableItems();
        for (int i = 0; i < aps.size(); i++) {
            ApunteDTO ap = aps.get(i);
            CuentaContable cc = ap.getCuentaContable();
            if (cc == null) continue;
            if ("40,41,47".indexOf(cc.getCodigo().substring(0,2))==-1){
                if (ap.getImporteDebe()!=null)
                    estimacion += ap.getImporteDebe();
            }

        }
        return estimacion;
    }

    private double estimaBaseIrpfDeAsiento(){
        double estimacion = 0.0;
        List<ApunteDTO> aps = apuntesDtoDc.getMutableItems();
        for (int i = 0; i < aps.size(); i++) {
            ApunteDTO ap = aps.get(i);
            CuentaContable cc = ap.getCuentaContable();
            if (cc == null) continue;
            if ("40,41,47".indexOf(cc.getCodigo().substring(0,2))==-1){
                if (ap.getImporteHaber()!=null)
                    estimacion += ap.getImporteDebe();
            }

        }
        return estimacion;
    }

    @Subscribe("addImputacion")
    public void onAddImputacionClick(Button.ClickEvent event) {
        ImputacionCentroDeCosteEdit icce = (ImputacionCentroDeCosteEdit) screenBuilders.editor(ImputacionCentroDeCoste.class, this).newEntity()
                .withOpenMode(OpenMode.DIALOG)
                .withParentDataContext(dataContext).build();
        icce.addAfterCloseListener(e->{
           if (e.getCloseAction()==StandardEditor.WINDOW_COMMIT_AND_CLOSE_ACTION){
               imputacionesDc.getMutableItems().add(icce.getEditedEntity());
               asientoDc.getItem().getImputacionesCentroDeCoste().add(icce.getEditedEntity());
           }
        });
        icce.addAfterShowListener(e->{
           icce.setAsiento(this.getEditedEntity());
        });

        icce.show();
    }

    @Subscribe("edtImputacion")
    public void onEdtImputacionClick(Button.ClickEvent event) {
        ImputacionCentroDeCoste icc = imputacionesTable.getSingleSelected();
        if (icc == null){
            notifications.create().withCaption("Seleccionar imputacion").show();
            return;
        }else{
            ImputacionCentroDeCosteEdit icce = (ImputacionCentroDeCosteEdit) screenBuilders.editor(ImputacionCentroDeCoste.class, this)
                    .editEntity(icc).withParentDataContext(dataContext).withOpenMode(OpenMode.DIALOG)
                    .build();
            icce.addAfterCloseListener(e->{
                if (e.getCloseAction()==StandardEditor.WINDOW_COMMIT_AND_CLOSE_ACTION){
                    if (imputacionesDc.getMutableItems().indexOf(icce.getEditedEntity())==-1){
                        imputacionesDc.getMutableItems().add(icce.getEditedEntity());
                    }else{
                        imputacionesDc.getMutableItems().set(imputacionesDc.getMutableItems().indexOf(icce.getEditedEntity()), icce.getEditedEntity());
                    }
                    if (asientoDc.getItem().getImputacionesCentroDeCoste().indexOf(icce.getEditedEntity())==-1){
                        asientoDc.getItem().getImputacionesCentroDeCoste().add(icce.getEditedEntity());
                    }else{
                        asientoDc.getItem().getImputacionesCentroDeCoste().set(asientoDc.getItem().getImputacionesCentroDeCoste().indexOf(icce.getEditedEntity()), icce.getEditedEntity());
                    }

                }
            });
            icce.show();
        }
    }

    @Subscribe("rmvImputacion")
    public void onRmvImputacionClick(Button.ClickEvent event) {
        ImputacionCentroDeCoste icc = imputacionesTable.getSingleSelected();
        if (icc == null){
            notifications.create().withCaption("Seleccionar imputacion").show();
            return;
        }else{
            dialogs.createOptionDialog()
                    .withCaption("¿Desea borrar la imputacion seleccionada?").withActions(
                            new DialogAction(DialogAction.Type.YES).withHandler(e->{
                                dataContext.remove(icc);
                                imputacionesDc.getMutableItems().remove(icc);
                            }),
                            new DialogAction(DialogAction.Type.NO).withHandler(e->{
                                //nothing
                            })
                    ).show();

        }
    }








    
    
    
    




}