package contabilidad.screen.centrodecoste;

import contabilidad.entity.Asiento;
import contabilidad.entity.CentroDeCoste;
import contabilidad.entity.PlanContable;
import io.jmix.core.DataManager;
import io.jmix.core.LoadContext;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.Tree;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.*;

@UiController("contabi_SeleccionCentroCoste")
@UiDescriptor("seleccion-centro-coste.xml")
public class SeleccionCentroCoste extends Screen {

    PlanContable planContable = null;

    CentroDeCoste centroDeCosteSeleccionado = null;

    @Autowired
    private DataManager dataManager;
    @Autowired
    private Button btnExpandir;
    @Autowired
    private Tree<CentroDeCoste> treeCentrosDeCoste;
    @Autowired
    private Button btnColapsar;
    @Autowired
    private CollectionLoader<CentroDeCoste> centroCosteDl;

    public void setPlanContable(PlanContable pc){
        this.planContable = pc;
        centroCosteDl.load();
        treeCentrosDeCoste.expandTree();
    }

    public CentroDeCoste getSeleccion(){
        return this.centroDeCosteSeleccionado;
    }

    @Subscribe
    public void onAfterInit(AfterInitEvent event) {
        btnExpandir.addClickListener(e->{
            if (treeCentrosDeCoste.getSingleSelected()!=null){
                treeCentrosDeCoste.expand(treeCentrosDeCoste.getSingleSelected());
            }else{
                treeCentrosDeCoste.expandTree();
            }

        });
        btnColapsar.addClickListener(e->{
            if (treeCentrosDeCoste.getSingleSelected()!=null){
                treeCentrosDeCoste.collapse(treeCentrosDeCoste.getSingleSelected());
            }else{
                treeCentrosDeCoste.collapseTree();
            }
        });


    }

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        treeCentrosDeCoste.expandTree();
    }






    @Install(to = "centroCosteDl", target = Target.DATA_LOADER)
    private List<CentroDeCoste> centroCosteDlLoadDelegate(LoadContext<CentroDeCoste> loadContext) {
        ArrayList<CentroDeCoste> al =  new ArrayList<CentroDeCoste>();
        CentroDeCoste root = this.planContable.getCentroDeCosteRoot();
        root = dataManager.load(CentroDeCoste.class).id(root.getId()).fetchPlan("fp-centro-de-coste-recursivo").one();
        al.add(root);
        Iterator<CentroDeCoste> descendientes = new ArrayList(root.getDescendientes()).listIterator();
        //rellenando los descendientes
        List<Iterator> iterators = new ArrayList<Iterator>();
        a:
        while(true){
            while(descendientes.hasNext()){
                CentroDeCoste cc = descendientes.next();

                al.add(cc);
                cc = dataManager.load(CentroDeCoste.class).id(cc.getId()).fetchPlan("fp-centro-de-coste-recursivo").one();
                if (cc.getDescendientes().size()>0){
                    iterators.add(descendientes);
                    descendientes = cc.getDescendientes().listIterator();
                }

            }
            if (iterators.size()>0) {
                descendientes = iterators.get(iterators.size() - 1);
                iterators.remove(descendientes);
            }else{
                break a;
            }

        }
        Collections.sort(al, new Comparator<CentroDeCoste>() {
            @Override
            public int compare(CentroDeCoste o1, CentroDeCoste o2) {
                return o1.getNombre().compareTo(o2.getNombre());
            }
        });
        return al;
    }

    @Subscribe("select")
    public void onSelectClick(Button.ClickEvent event) {
        this.centroDeCosteSeleccionado = treeCentrosDeCoste.getSingleSelected();
        this.close(Screen.WINDOW_CLOSE_ACTION);
    }

    @Subscribe("cancel")
    public void onCancelClick(Button.ClickEvent event) {
        this.centroDeCosteSeleccionado = null;
        this.close(Screen.WINDOW_CLOSE_ACTION);
    }







}