package contabilidad.screen.ejercicio;

import contabilidad.beans.EjercicioBean;
import contabilidad.beans.SaldosBean;
import contabilidad.entity.Empresa;
import contabilidad.entity.PlanContable;
import contabilidad.entity.SaldoCuentaEjercicio;
import contabilidad.screen.volcadosaldosiniciales.VolcadoSaldosIniciales;
import io.jmix.core.DataManager;
import io.jmix.core.EntityStates;
import io.jmix.ui.Dialogs;
import io.jmix.ui.Notifications;
import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.action.Action;
import io.jmix.ui.action.DialogAction;
import io.jmix.ui.component.CheckBox;
import io.jmix.ui.component.DateField;
import io.jmix.ui.component.EntityPicker;
import io.jmix.ui.component.TextField;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.*;
import contabilidad.entity.Ejercicio;
import org.springframework.beans.factory.annotation.Autowired;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@UiController("contabi_Ejercicio.edit")
@UiDescriptor("ejercicio-edit.xml")
@EditedEntityContainer("ejercicioDc")
public class EjercicioEdit extends StandardEditor<Ejercicio> {

    @Autowired
    private DateField<Date> fechaInicioField;
    @Autowired
    private EntityStates entityStates;
    @Autowired
    private DateField<Date> fechaFinField;
    @Autowired
    private InstanceContainer<Ejercicio> ejercicioDc;
    @Autowired
    private EntityPicker<Empresa> empresaField;
    @Autowired
    private CheckBox chbBloqueado;
    @Autowired
    private EntityPicker<PlanContable> planContableField;
    @Autowired
    private TextField<Integer> annoField;
    @Autowired
    private EjercicioBean ejercicioBean;
    @Autowired
    private Notifications notifications;
    @Autowired
    private DataManager dataManager;
    @Autowired
    private SaldosBean saldosBean;
    @Autowired
    private Dialogs dialogs;
    @Autowired
    private ScreenBuilders screenBuilders;


    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        if (entityStates.isNew(this.getEditedEntity())){
            planContableField.addValueChangeListener(e->{
                SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
                try{
                    if (e.getValue()!=null){
                        Empresa emp = e.getValue().getEmpresa();
                        ejercicioDc.getItem().setEmpresa(emp);
                        ejercicioDc.getItem().setAnno(ejercicioBean.devuelveAnnoParaNuevoEjercicioPara(e.getValue()));
                        Integer anno = ejercicioDc.getItem().getAnno();
                        Date fechaInicio = sdf.parse("01/01/" + anno.toString());
                        Date fechaFin = sdf.parse("31/12/" + anno.toString());
                        ejercicioDc.getItem().setFechaInicio(fechaInicio);
                        ejercicioDc.getItem().setFechaFin(fechaFin);
                        ejercicioDc.getItem().setBloqueado(false);
                    }
                }catch(Exception exc){
                    notifications.create().withDescription("Error al calcular año de ejercicio : " + exc.getMessage()).show();
                }

            });
        }else{
            planContableField.setEditable(false);
        }
    }

    @Subscribe("windowCommitAndClose")
    public void onWindowCommitAndClose(Action.ActionPerformedEvent event) {
        //si este y el ejercicio anterior no estan bloqueados
        //pregunto si desea actualizar saldos iniciales para este ejercicio
        if (this.getEditedEntity().getBloqueado()){
            dialogs.createOptionDialog().withCaption("Saldos Iniciales")
                    .withMessage("Ha realizado el bloqueo del ejercicio, ¿desea realizar el volcado de Saldos Iniciales para el siguiente Ejercicio?")
                    .withActions(
                            new DialogAction(DialogAction.Type.YES).withCaption("Sí, realizar volcado").withHandler(e->{
                                VolcadoSaldosIniciales vsi = (VolcadoSaldosIniciales) screenBuilders.screen(this).withScreenId("contabi_VolcadoSaldosIniciales")
                                        .withOpenMode(OpenMode.NEW_TAB).build();

                                vsi.show();
                                vsi.percargaInformacionParaEjercicio(this.getEditedEntity());

                            }),
                            new DialogAction(DialogAction.Type.NO).withCaption("No, lo hare en otro momento").withHandler(e->{
                                notifications.create().withCaption("Volcado de saldos pendiente").show();
                            })
                    ).show();
        }





    }

//    private void realizaVolcadoSaldos(){
//        Ejercicio ej = this.getEditedEntity();
//        try{
//            List<Ejercicio> ejsAnteriores = dataManager.load(Ejercicio.class)
//                    .query("select ej from contabi_Ejercicio ej join ej.planContable pc where ej.anno = :anno" +
//                            " and pc.id = :pcid")
//                    .parameter("anno", ej.getAnno()-1).parameter("pcid", ej.getPlanContable().getId()).list();
//            if (ejsAnteriores.size()==1){
//                Ejercicio ejAnterior = ejsAnteriores.get(0);
//                List<SaldoCuentaEjercicio> ssccee = saldosBean.calculaSaldosCuentaEjercicioPara(ej);
//
//            }else{
//                notifications.create().withDescription("No se pudo hallar el ejercicio anterior para la verificacion de saldos").show();
//            }
//        }catch(Exception exc){
//
//        }
//    }


}