package contabilidad.screen.ejercicio;

import contabilidad.entity.Ejercicio;
import contabilidad.entity.User;
import io.jmix.core.DataManager;
import io.jmix.core.security.CurrentAuthentication;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.EntityPicker;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.Screen;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("contabi_EstablecerEjercicioActivo")
@UiDescriptor("establecer-ejercicio-activo.xml")
public class EstablecerEjercicioActivo extends Screen {

    @Autowired
    private InstanceContainer<Ejercicio> ejercicioDc;

    @Autowired
    private Button btnCancelar;
    @Autowired
    private Button btnOk;
    @Autowired
    private EntityPicker<Ejercicio> pckEjercicio;
    @Autowired
    private CurrentAuthentication currentAuthentication;
    @Autowired
    private Notifications notifications;
    @Autowired
    private DataManager dataManager;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        User u = ((User)currentAuthentication.getUser());
        if (u.getEjercicioActivo()!=null){
            pckEjercicio.setValue(u.getEjercicioActivo());

        }



    }

    @Subscribe("btnOk")
    public void onBtnOkClick(Button.ClickEvent event) {
        User u = ((User)currentAuthentication.getUser());
        if (pckEjercicio.getValue()!=null){
            u = dataManager.load(User.class).id(u.getId()).one();

            u.setEjercicioActivo(pckEjercicio.getValue());
            dataManager.save(u);
            ((User)currentAuthentication.getUser()).setEjercicioActivo(pckEjercicio.getValue());
            this.closeWithDefaultAction();
            notifications.create().withCaption("Ejercicio " + pckEjercicio.getValue().getDescriptivo() + " establecido como activo").show();
        }else{
            notifications.create().withCaption("Seleccionar un ejercicio activo").show();
        }
    }

    @Subscribe("btnCancelar")
    public void onBtnCancelarClick(Button.ClickEvent event) {
        this.closeWithDefaultAction();
    }






}