package contabilidad.screen.publicacionremota;

import contabilidad.beans.app.ContabilizacionExternaBean;
import contabilidad.entity.Asiento;
import contabilidad.screen.asiento.AsientoEdit2;
import io.jmix.core.DataManager;
import io.jmix.ui.Notifications;
import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.UiComponents;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.GroupTable;
import io.jmix.ui.component.Label;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import contabilidad.entity.PublicacionRemota;
import org.apache.tomcat.util.json.JSONParser;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.Map;

@UiController("contabi_PublicacionRemota.browse")
@UiDescriptor("publicacion-remota-browse.xml")
@LookupComponent("publicacionRemotasTable")
public class PublicacionRemotaBrowse extends StandardLookup<PublicacionRemota> {

    @Autowired
    private ContabilizacionExternaBean contabilizacionExternaBean;
    @Autowired
    private GroupTable<PublicacionRemota> publicacionRemotasTable;
    @Autowired
    private Notifications notifications;
    @Autowired
    private ScreenBuilders screenBuilders;
    @Autowired
    private DataManager dataManager;
    @Autowired
    private UiComponents uiComponents;
    @Autowired
    private CollectionLoader<PublicacionRemota> publicacionRemotasDl;

    @Subscribe
    public void onAfterInit(AfterInitEvent event) {
        publicacionRemotasTable.addGeneratedColumn("ampliacion", e->{
            Label l = uiComponents.create(Label.NAME);
            try{
                String json = e.getContenido();
                JSONParser parser = new JSONParser(json);
                Map m = (Map) parser.parse();
                String s = m.get("NOMBRE_EMISOR") + " " + m.get("NUM_FRA");
                l.setValue(s);
            }catch(Exception exc){

            }
            return l;

        });
    }



    @Subscribe("btnCrearAsiento")
    public void onBtnCrearAsientoClick(Button.ClickEvent event) {
        PublicacionRemota pr = publicacionRemotasTable.getSingleSelected();
        if (pr==null){
            notifications.create().withCaption("Seleccionar un registro").show();
        }
        if ((pr.getIdAsientoProcesado()!=null) && (pr.getFechaProcesamiento()!=null)){
            notifications.create().withCaption("La publicacion seleccionada ya fue procesada")
                    .withDescription("Para volver a procesarla edite la publicacion y borre los campos " +
                            "idNumAsiento y fecha de procesamiento").show();
            return;
        }
        try {
            Asiento a = contabilizacionExternaBean.realizaAsientoDesdePublicacionRemota(pr);
            AsientoEdit2 ae2scr = (AsientoEdit2)screenBuilders.editor(Asiento.class, this).withScreenId("contabi_Asiento.edit2")
                    .editEntity(a).withOpenMode(OpenMode.NEW_TAB).build();
            ae2scr.addAfterCloseListener(e->{
                if (((StandardCloseAction)e.getCloseAction()).getActionId().compareTo("commit")==0){
                    AsientoEdit2 ae2 = (AsientoEdit2) e.getSource();
                    pr.setFechaProcesamiento(new Date());
                    pr.setIdAsientoProcesado(ae2.getEditedEntity().getNumAsiento().toString());
                    dataManager.save(pr);
                    publicacionRemotasDl.load();
                }

            });
            ae2scr.show();
        } catch (Exception e) {
            notifications.create().withCaption(e.getMessage()).show();
        }
    }


}